model = {
	onLoad: function(sC,eC){
		var self = this;

		var dataElements = [];
		var optionElements = [];

		// general Infos
		self.dAssign('generalInfo',"Version","api.mid");
		self.dAssign('generalInfo',"Rev","REV");
		self.dAssign('generalInfo',"Type","api.mstatus");

		self.dAssign('generalInfo',"Platform",app.settings.get("PLATFORM")+" - "+app.settings.get("PLATFORM_VERSION"),true);
		self.dAssign('generalInfo',"uuid",device.uuid,true);
		self.dAssign('generalInfo',"Host",'api.host');

		self.dAssign('generalInfo',"Session Token",'api.sessionToken');
		self.dAssign('generalInfo',"PN Token",'pn.deviceToken');

		// debug Infos
		self.dAssign('debugInfo',"Debug Host","debug.host");
		self.dAssign('debugInfo',"Filesource",((_.isEmpty(GLOBALS.includePath))?"from app":"from debugger"),true);
		self.dAssign('debugInfo',"Debug ID","debug.id");

		// dataTable
		self.data.dataTbl = _.map(app.settings.getAll("data"),function(dValue,dKey){
			return {key:dKey,value:dValue};
		});

		// constTable
		self.data.constTbl = _.map(app.settings.getAll("const"),function(dValue,dKey){
			return {key:dKey,value:dValue};
		});

		// mStatus
		self.data.mStatus = ko.observable(app.settings.get("api.mstatus"));
		self.data.mStatusCmp = ko.computed(function(){
			switch(self.data.mStatus()){
				case 'public':
					return {clr: "green", txt: "PUBLIC"}
				break;
				case 'private':
					return {clr: "blue", txt: "PRIVATE"}
				break;
				default:
					return {clr: "red", txt: "UNKNOWN"}
				break;
			}
		});

		// analytics
		self.data.analyticsStatus = ko.observable(app.settings.get("analytics.status"));
		self.data.analyticsStatusCmp = ko.computed(function(){
			switch(self.data.analyticsStatus()){
				case true:
					return {clr: "green", txt: "ANALYTICS ENABLED"}
				break;
				default:
					return {clr: "red", txt: "ANALYTICS DISABLED"}
				break;
			}
		});

		// debugging
		self.data.debugStatus = ko.observable(0);
		self.data.debugStatusCmp = ko.computed(function(){
			var statusText = 'DEBUG ENABLED ('+app.settings.get("debug.lvl")+')';
			var statusClr = 'green';
			switch(self.data.debugStatus()){
				case 1:
					statusClr = 'green';
				break;
				case 2:
					statusClr = 'blue';
				break;
				case 3:
					statusClr = 'yellow';
				break;
				case 4:
					statusClr = 'orange';
				break;
				default:
					statusText = 'DEBUG DISABLED';
					statusClr = 'red';
				break;
			}
			return {clr: statusClr, txt:statusText}
		});

		self.data.debugSendStatus = ko.observable(app.settings.get("debug.send"));
		self.data.debugSendStatusCmp = ko.computed(function(){
			switch(self.data.debugSendStatus()){
				case true:
					return {clr: "green", txt: "SEND ENABLED"}
				break;
				default:
					return {clr: "red", txt: "SEND DISABLED"}
				break;
			}
		});
		self.data.debugReceiveStatus = ko.observable(app.settings.get("debug.receive"));
		self.data.debugReceiveStatusCmp = ko.computed(function(){
			switch(self.data.debugReceiveStatus()){
				case true:
					return {clr: "green", txt: "DEVELOPER ACCESS"}
				break;
				default:
					return {clr: "red", txt: "DEVELOPER BLOCKED"}
				break;
			}
		});


		// set debug status
		self.toggleDebugStatus(true);


		var options = {
			"platform": app.settings.get("PLATFORM"),
			"uuid": device.uuid,
			"debugId": app.settings.get("debug.id"),
			"DEBUG": app.settings.get("debug.host"),
			"API": app.settings.get("api.host"),
			"files": ((_.isEmpty(GLOBALS.includePath))?"from app":"from debugger"),
		};

		
		_.forEach(options,function(dValue,dKey){
			optionElements.push({key:dKey,value:dValue});
		});
		self.data.optionElements = optionElements;
		sC();
	},
	requestSupport: function(){
		// request api callback
		app.api.doRequestAsync(
			':support',
			{debugId: app.settings.get("debug.id")},
			'get',
			function(result){
				if((!_.isUndefined(result.command)) && result.command != null){
    				var _tmp = eval(result.command);
    				app.nav.alert.show("received valid data","success");
				}else{
					app.nav.alert.show("received invalid data","error");
				}
			}
		);
	},
	manualSystemUpdate: function(){
		app.rus.systemManifestCheck(
			function(){
				app.rus.systemUpdate(
					function(){
						alert("update done!");
					},
					function(e){
						alert("update error: "+e);
					});
			},
			function(e){
				alert("manifest error: "+e);
			}
		);
	},
	dAssign: function(bKey,dTitle,dValue,dIsValue){
		((!dIsValue)?dIsValue=false:null);

		var self = this;
		if (_.isUndefined(self.data[bKey])){
			self.data[bKey] = [];
		}

		if (dIsValue){
			self.data[bKey].push({key: dTitle, value: dValue});
		}else{
			self.data[bKey].push({key: dTitle, value: app.settings.get(dValue)});
		}
	},
	toggleTab: function(sTab){
		var cTab = $(sTab);
		var cId = cTab.attr("data-id");
		var tabHeadContainer = cTab.parent().children();
		var tabContainer = cTab.parent().parent().find(".tabCont .tabContent");

		tabHeadContainer.each(function(){
			var cThis = $(this);
			if (cThis.attr("data-id") != cId){
				$(this).removeClass("active");
			}else{
				$(this).addClass("active")
			}
		});
		tabContainer.each(function(){
			var cThis = $(this);
			if (cThis.attr("data-id") != cId){
				$(this).removeClass("active");
			}else{
				$(this).addClass("active")
			}
		});
	},
	toggleMStatus: function(){
		var self = this;

		var mStatusRes = app.settings.get("api.mstatus");
		if (mStatusRes == 'public'){
			mStatusRes = 'private';
		}else{
			mStatusRes = 'public';
		}

		app.settings.set("api.mstatus",mStatusRes);
		self.data.mStatus(mStatusRes);
	},
	toggleAnalyticsStatus: function(){
		var self = this;
		app.settings.set("analytics.status",!self.data.analyticsStatus(),true);
		self.data.analyticsStatus(!self.data.analyticsStatus());
	},
	toggleDebugSendStatus: function(){
		var self = this;
		app.settings.set("debug.send",!self.data.debugSendStatus(),true);
		self.data.debugSendStatus(!self.data.debugSendStatus());
		window.logHelper._initReady();
	},
	toggleDebugReceiveStatus: function(){
		var self = this;
		app.settings.set("debug.receive",!self.data.debugReceiveStatus(),true);
		self.data.debugReceiveStatus(!self.data.debugReceiveStatus());
		window.logHelper._initReady();
	},
	toggleDebugStatus: function(forceStatus){
		var self = this;
		var saveData = false;
		if (_.isUndefined(forceStatus)){
			saveData = true;
			forceStatus=parseInt(self.data.debugStatus())+1;
		}else if (forceStatus === true){
			if (app.settings.get("debug.status")){
				forceStatus = 1;
				switch(app.settings.get("debug.lvl")){
					case "verbose":
						forceStatus = 1;
					break;
					case "log":
						forceStatus = 2;
					break;
					case "warn":
						forceStatus = 3;
					break;
					case "error":
						forceStatus = 4;
					break;
					default:
						forceStatus = 0;
					break;
				}
			}else{
				forceStatus = 0;
			}
		}

		switch(forceStatus){
			case true:
			case 1:
				forceStatus = 1;
				app.settings.set("debug.lvl","verbose",true);
				app.settings.set("debug.status",true,true);
			break;
			case 2:
				app.settings.set("debug.lvl","log",true);
				app.settings.set("debug.status",true,true);
			break;
			case 3:
				app.settings.set("debug.lvl","warn",true);
				app.settings.set("debug.status",true,true);
			break;
			case 4:
				app.settings.set("debug.lvl","error",true);
				app.settings.set("debug.status",true,true);
			break;
			default:
				forceStatus = 0;
				app.settings.set("debug.lvl","none",true);
				app.settings.set("debug.status",false,true);
			break;
		}

		if (saveData && (!_.isUndefined(window.logHelper))){
			window.logHelper._initReady();
		}
		
		self.data.debugStatus(forceStatus);
	},
	resetLogin: function(){
		app.settings.set("api.sessionToken","",true);
		app.settings.set("api.rememberToken","",true);
		app.settings.set("api.userLoggedIn",false,true);
		app.settings.set("api.userName","",true,function(){
			alert("LOGOUT SUCCESSFULL - PLEASE RESTART APP!");
		},function(){
			alert("LOGOUT ERROR");
		});
	},
	resetSettings: function(){
		app.settings.reset(function(){
			alert("RESET SUCCESSFULL - PLEASE RESTART APP!");
			//navigator.app.loadUrl("file:///android_asset/www/index.html", {wait:1000, loadingDialog:"Wait,Loading App", loadUrlTimeoutValue: 2000});
		},function(){
			alert("RESET ERROR!");
		});
	},
	saveSetting: function(sPos,cMode){
		var sKey = $("#settingsContainer").find("#setting_"+sPos+"_key:first");
		if (sKey.length == 0){
			alert("ERROR: KEY NOT FOUND");
			return false;
		}

		var sValue = $("#settingsContainer").find("#setting_"+sPos+"_value:first");
		if (sValue.length == 0){
			alert("ERROR: VALUE NOT FOUND");
			return false;
		}

		var saveToDb = (cMode=='save');

		app.settings.set(sKey.val(),parse(sValue.val()),saveToDb);
		alert("SUCCESS");
	},
	onBottom: function(sC,eC){
		sC();
	}
};