model = {
	// definitions
	_def: {
		currency: "€",
		searchStatus: null,
		filter: {
			rangeMin: 1,
			rangeMax: 250,
			maxPriceDefault: 100,
			colorDefault: [],
			inSaleDefault: false,
			searchQueryDefault: ''
		}
	},
	onLoad: function(sC,eC){
		var self = this;
		var cPage = self.page.get();

		if(app.settings.get('CURRENCY').toLowerCase() == 'eur'){
			self._def.currency = "€";
			self._def.filter.rangeMax = 250;
			self._def.filter.maxPriceDefault = 100;
		}
		else if(app.settings.get('CURRENCY').toLowerCase() == 'gbp'){
			self._def.currency = "£";
			self._def.filter.rangeMax = 200;
			self._def.filter.maxPriceDefault = 80;
		}
		else if(app.settings.get('CURRENCY').toLowerCase() == 'pln'){
			self._def.currency = "zł";
			self._def.filter.rangeMax = 1000;
			self._def.filter.maxPriceDefault = 400;
		}

		var sliderTextContainer = null;

		self.filterCallback = null;

		cPage.find('.filter-bar:first').slider({
            range: "min",
            value: self._def.filter.maxPriceDefault,
            min: self._def.filter.rangeMin,
            max: self._def.filter.rangeMax,
            slide: function(e,uiSlider) {
            	sliderTextContainer.text('0 - ' + uiSlider.value + ' '+self._def.currency);
            }
        });
        self.uiSlider = cPage.find('.filter-bar:first');

        cPage.find('.ui-slider-handle').append('<p class="filter-point"></p><p class="filter-count">0 - '+ self._def.filter.maxPriceDefault + ' '+self._def.currency+'</p>');
        sliderTextContainer = cPage.find('.filter-count:first');
        
		cPage.find('.black-background').get(0).addEventListener('touchend', function(){
			self.filterToggle();
			console.log('touchend');
		}, false);

		sC();
	},
	onFocus: function(sC,eC){
		var self = this;
		sC();
	},
	afterShow: function(sC,eC){
		var self = this;
		sC();
	},
	setValues: function(nValues){
		var self = this;
		var cPage = self.page.get();
		if(app.settings.get('CURRENCY').toLowerCase() == 'gbp'){
			nValues.maxPrice = Math.floor(nValues.maxPrice / app.settings.get('CURRENCY_GBP'));
		}
		else if(app.settings.get('CURRENCY').toLowerCase() == 'pln'){
			nValues.maxPrice = Math.floor(nValues.maxPrice / app.settings.get('CURRENCY_PLN'));
		}
		self.uiSlider.slider("value",nValues.maxPrice);
		cPage.find('.filter-count:first').text('0 - ' + nValues.maxPrice + ' '+self._def.currency);
		cPage.find('.search-container:first').find('input:first').val(nValues.searchQuery);
		var cCircle = cPage.find('.color-container').find('.circle');
		_(nValues.color).forEach(function(cElement){
			if(cCircle.attr('data-search-value') == cElement){
				cCircle.addClass('active');
			}
		});
		cPage.find('#filter_inSale').prop('checked', nValues.inSale);
	},
	getValues: function(){
		var self = this;
		var cPage = self.page.get();
		var searchQuery = cPage.find('.search-container:first').find('input:first').val();
		var maxPrice = self.uiSlider.slider("value");
		var cColors = [];
		cPage.find('.color-container').find('.active').each(function(){
			cColors.push($(this).attr('data-search-value'));
		});
		console.log(cColors);
		var inSale = cPage.find('#filter_inSale').prop('checked');

		if(app.settings.get('CURRENCY').toLowerCase() == 'gbp'){
			maxPrice = Math.floor(maxPrice / app.settings.get('CURRENCY_GBP'));
		}
		else if(app.settings.get('CURRENCY').toLowerCase() == 'pln'){
			maxPrice = Math.floor(maxPrice / app.settings.get('CURRENCY_PLN'));
		}

		var cValues = {
			'searchQuery':searchQuery,
			'maxPrice':maxPrice,
			'color':cColors,
			'inSale':inSale
		}
		return cValues;
	},
	registerCallback: function(fFunc){
		var self = this;
		self.filterCallback = fFunc;
	},
	setCurrency: function(nValue){
		self._def.currency = nValue;
	},
	filterToggle: function(){
		var self = this;
		var cPage = self.page.get();

		var iFilter = $('#filter');

		if(!iFilter.hasClass("active")){
			iFilter.addClass('active');
			self.toggleSearch(false);
			//iFilter.find(".filter-content:first").css({'display':'block'});
		}else{
			iFilter.removeClass('active');
			if(self._def.searchStatus!==null && self._def.searchStatus===true){
				self.toggleSearch(true);
			}
			//iFilter.find(".filter-content:first").css({'display':'none'});
			if (!_.isNull(self.filterCallback)){
				self.filterCallback(self.getValues());
			}
		}
	},
	toggleSearch: function(displayStatus, saveThisStatus){
		var self = this;
		var cPage = self.page.get();
		if(_.isUndefined(displayStatus)){
			displayStatus = !(cPage.parent().hasClass('search-filter'));
		}
		if(displayStatus){
			cPage.parent().addClass('search-filter');
			cPage.find('.filter-header').css({'display':'block'});
		}
		else{
			cPage.parent().removeClass('search-filter');
			cPage.find('.filter-header').css({'display':'none'});
		}
		if(!(_.isUndefined(saveThisStatus)) && saveThisStatus){
			self._def.searchStatus = displayStatus;
		}
	},
	toggleColors: function(displayStatus){
		var self = this;
		var cPage = self.page.get();
		if(_.isUndefined(displayStatus)){
			if(cPage.find('.filter-color').css('display')=='block'){
				displayStatus = false;
			}
			else{
				displayStatus = true;
			}
		}
		if(displayStatus){
			cPage.find('.filter-color').css({'display':'block'});
		}
		else{
			cPage.find('.filter-color').css({'display':'none'});
		}
	},
	toggleSale: function(displayStatus){
		var self = this;
		var cPage = self.page.get();
		if(_.isUndefined(displayStatus)){
			if(cPage.find('.filter-sale').css('display')=='block'){
				displayStatus = false;
			}
			else{
				displayStatus = true;
			}
		}
		if(displayStatus){
			cPage.find('.filter-sale').css({'display':'block'});
		}
		else{
			cPage.find('.filter-sale').css({'display':'none'});
		}
	},
	setColorsAndSale: function(displayStatus){
		var self = this;
		var cPage = self.page.get();
		if(_.isUndefined(displayStatus)){
			console.error('set true or false!');
		}
		else{
			self.toggleColors(displayStatus);
			self.toggleSale(displayStatus);
			if(displayStatus){
				cPage.find('.inner-wrapper').addClass('full-filter');
			}
			else{
				cPage.find('.inner-wrapper').removeClass('full-filter');
			}
		}
	},
	search: function(cObj){
		var self = models('#filter');
		event.preventDefault();
		var searchInput = $(cObj).parent().find('input:first');
		searchInput.blur();
		console.log(searchInput);
		//app.nav.loadPage('#searchResult', {'id':searchInput.val()});
		if (!_.isNull(self.filterCallback)){
			self.filterCallback(self.getValues());
		}
	},
	toggleColor: function(cObj){
		if($(cObj).hasClass('active')){
			$(cObj).removeClass('active');
		}
		else{
			$(cObj).addClass('active');
		}
	},
	searchGetFocus: function(cObj){
		$(cObj).parent().addClass('active');
		app.nav.hideLevel(2);
	},
	searchLooseFocus: function(cObj){
		setTimeout(function(){
			$(cObj).parent().removeClass('active');
		}, 50);
		app.nav.showLevel(2);
	}
};