model = {
	_def: {
		cartFallbackTimeout: 2500	// timeout in ms
	},
	onLoad: function(sC,eC){
		var self = this;

		// create a new observable
		self.data.isBackable = ko.observable(false);

		// create a new observable
		self.data.cartCountValue = ko.observable(0);

		// register function to observe
		self.register("refreshHistory",function(pMdl){
			var obsObj = self.data.isBackable;
			if (app.nav.page.goBackAvailable() && (!obsObj())){
				obsObj(true);
			}else if ((!app.nav.page.goBackAvailable()) && (obsObj())){
				obsObj(false);
			}
		});

		sC();
	},
	changeHeader: function(whatToShow, text){
		((!whatToShow)?whatToShow='logo':null);
		((!text)?text='':null);
		var self = this;

		var cPage = self.page.get();

		var logoContainer = cPage.find("[data-type='logo']:first");
		var textContainer = cPage.find("[data-type='text']:first");
		var basketContainer = cPage.find("[data-type='basket']:first");
		
		if(whatToShow=='text'){
			textContainer.children("h2:first").html(text);
			textContainer.addClass("transition-fade-box-in").removeClass("transition-fade-box-out");
			logoContainer.addClass("transition-fade-box-out").removeClass("transition-fade-box-in");
			console.log('header.text: '+text);
			textContainer.parent().removeAttr('onclick');
		}else if(whatToShow=='basket_show'){
			basketContainer.css({'display':'block'});
			basketContainer.addClass("transition-fade-box-in").removeClass("transition-fade-box-out");
		}else if(whatToShow=='basket_hide'){
			basketContainer.addClass("transition-fade-box-out").removeClass("transition-fade-box-in");
		}else{
			logoContainer.addClass("transition-fade-box-in").removeClass("transition-fade-box-out");
			textContainer.addClass("transition-fade-box-out").removeClass("transition-fade-box-in");
			console.log('header.logo');
			textContainer.parent().attr({'onclick':"app.nav.loadPage('#inspireSources', {force:true});"});
		}
	},
	_getCartSourceUrl: function(){
		var rToken = app.settings.get("api.sessionToken");
		if (!rToken){
			// show alert message
			app.nav.alert.show($.t('cart.messages.missingSessionToken'),"error");
			return false;
		}

		var cartFrameSource = "https://"+app.settings.get('LANGUAGE')+".dawanda.com/cart/show?mobile=cc813c2796e739d647346215a0ed147d&utm_nooverride=1&utm_source="+app.settings.get('LANGUAGE')+"_mobapp&utm_content="+app.settings.get('LANGUAGE')+"_mobapp&partnerid="+app.settings.get('LANGUAGE')+"_mobapp&_dawanda_session="+rToken;
		return cartFrameSource;
	},
	showCart: function(){
		var self = this;

		cartFrameSource = self._getCartSourceUrl();
		if (!cartFrameSource){
			return false;
		}

		// set local used vars
		var cCartWindow = null;
		var cCartShowStatus = false;

		// show loading container
		app.nav.showContainer('loading', true);

		// create a fallback timeout, to show the window after x seconds
		if (self._def.cartFallbackTimeout > 0){
			window.setTimeout(function(){
				if (!cCartShowStatus){
	        		cCartWindow.show();
					app.nav.hideContainer('loading');
					console.info("cartWindow.fallbackTimeout: "+self._def.cartFallbackTimeout);
	        	}
			},self._def.cartFallbackTimeout);
		}		

		// create new window
		cCartWindow = window.open(cartFrameSource, '_blank', 'location=no,toolbar=no,hidden=yes,clearcache=yes,clearsessioncache=yes');
		cCartWindow.addEventListener('loadstart', function(event){
			// check cart close regex
			if(event.url.match(/https:\/\/(.*).dawanda.com\/cart\/close/gi)){
				cCartWindow.close();
				delete cCartWindow;
			}
			console.info('cartWindow.loadstart');
		});
		cCartWindow.addEventListener('loadstop', function(event){
			cCartShowStatus = true;

			cCartWindow.show();			
			app.nav.hideContainer('loading');

			console.info('cartWindow.loadstop');
		});
		cCartWindow.addEventListener('exit', function(event){
			// refresh cart items badget
			app.api.doAPIRequestAsync(
				':api',
				'cart_items/count',
				{},
				'get',
				function(result){
					if(result.result===true){
						app.system.cartCountValue(result.data);
					}
				}
			);
		});

		// close cartWindow on offline
        document.addEventListener('offline', function(){
        	cCartWindow.close();
        	delete cCartWindow;
        }, false);
	}
};