model = {
	onLoad: function(sC,eC){
		var self = this;
		var cPage = self.page.get();

		// inspire elements
		self.inspireData = {};

		// slot position-data || {pos: 1234, status: false, id: null}
		self.slotData = [];

		sC();
	},
	onFocus: function(sC,eC){
		var self = this;
		models("#header").changeHeader('logo_show');
		models("#footer").data.activeTab("star");
		sC();
	},
	onBlur: function(sC,eC){
		var self = this;
		//models("#footer").data.activeTab("");
		sC();
	},
	afterShow: function(sC,eC,eParams){
		var self = this;

		if(!eParams.firstCall){
			sC();
			return;
		}

		app.api.doAPIRequestAsync(
			':api',
			'inspiration_groups',
			{limit: 16},
			'get',
			function(result){
				if(result.result===true){
					_(result.data).forEach(function(cElement,cPos){
						// add inspire element to _cache
						self.inspireData[cElement.id] = cElement;

						// 'bind' inspire element with slot
						var slotDomPos = 1000;
						var cDataSlot = self.page.get().find("[data-slot='"+cPos+"']");
						if (cDataSlot.length > 0){
							slotDomPos = cDataSlot.position().top;
						}
						self.slotData.push({status: false, domPos: slotDomPos, id: cElement.id});
					});

					// fire onScroll for first elements
					self.onScroll(null,null,self.page.getScrollData());

					var remainingPages = {
						'#startup':true,
						'#header':true,
						'#footer':true,
						'#filter':true,
						'#share':true
					};
					remainingPages[self.id()]=true;
					app.nav.showContainer('loading', true);
					app.nav.history.remove(
						remainingPages,
						function(succ){
							app.nav.hideContainer('loading');
							sC();
						}
					);
				}
				else{
					if(result.result===false){
						app.nav.alert.show($.t('inspire.messages.errorUnknownError'),'error');
					}
					else{
						app.nav.alert.show($.t('inspire.messages.noProductsFound'),'info');
					}
					self.page.remove();
					eC();
				}
			},
			function(result){
				if(result.statusText=="timeout"){
					app.nav.alert.show($.t('inspire.messages.errorUnknownError'),'error');
				}
				self.page.remove();
				eC();
			}
		);
	},
	loadDataSlot: function(slotPos){
		var self = this;
		var cSlot = self.slotData[slotPos];
		// set status to active
		cSlot.status = true;

		var cElement = self.getInspireDataFor(cSlot.id);
		var cDataSlot = self.page.get().find("[data-slot='"+slotPos+"']");
		// prevent duplicated assignments
		if (cDataSlot.attr("assigned") == "1"){
			return false;
		}

		// format topic
		var newName = '';
		var cNameLength = cElement.name.length;
		// these slots are 100% width
		if(slotPos==0 || slotPos==3 || slotPos==7 || slotPos==8 || slotPos==12 || slotPos==13 || slotPos==14 || slotPos==15){
			if(cNameLength>25){
				//letztes leerzeichen in der ersten zeile wird gesucht
				var llz_z1 = cElement.name.substr(0,25).lastIndexOf(' ');
				if(llz_z1!=(-1)){
					newName = cElement.name.substr(0,llz_z1) + '<br />' + cElement.name.substr(llz_z1+1);
					cDataSlot.find('.title-vertical').addClass('two-lines');
				}
				else{
					//erstes leerzeichen in der zweiten zeile wird gesucht
					var llz_z1 = cElement.name.substr(25,25).indexOf(' ');
					if(llz_z1!=(-1)){
						cDataSlot.find('.title-vertical').addClass('two-lines');
					}
					newName = cElement.name;
				}
			}
			else{
				newName = cElement.name;
			}
		}
		// these slots are 50% width
		else{
			if(cNameLength>12){
				var lastBindeStrich_z1 = cElement.name.trim().substr(0,12).lastIndexOf('-');
				var lastBindeStrich_z2 = cElement.name.trim().substr(12,13).indexOf('-');
				var llz_z1 = cElement.name.trim().substr(0,12).lastIndexOf(' ');
				var llz_z2 = cElement.name.trim().substr(12,13).indexOf(' ');
				if(lastBindeStrich_z1!=(-1) || lastBindeStrich_z2!=(-1)){
					if(lastBindeStrich_z1!=(-1)){
						newName = cElement.name.substr(0,lastBindeStrich_z1+1) + '<br />' + cElement.name.substr(lastBindeStrich_z1+1);
						cDataSlot.find('.title-vertical').addClass('two-lines');
					}
					else{
						if(lastBindeStrich_z2!=(-1)){
							cDataSlot.find('.title-vertical').addClass('two-lines');
						}
						newName = cElement.name;
					}
				}
				else{
					if(llz_z1!=(-1)){
						newName = cElement.name.substr(0,llz_z1) + '<br />' + cElement.name.substr(llz_z1+1);
						cDataSlot.find('.title-vertical').addClass('two-lines');
					}
					else{
						if(llz_z2!=(-1)){
							cDataSlot.find('.title-vertical').addClass('two-lines');
						}
						newName = cElement.name;
					}
				}
			}
			else{
				newName = cElement.name;
			}
		}

		cDataSlot.click(function(){
			app.nav.loadPage('#inspireLvl2', {id:cElement.id, refPageId: self.id()});
		});

		// set topic
		cDataSlot.find('h2')
			.css({color: cElement.color})
			.html(newName);
			
		cDataSlot.find('img').attr('src','http:'+cElement.image_url);
		//cDataSlot.find('img').attr('src','http://valuestream2009.files.wordpress.com/2012/01/apple-logo-red.jpg');
		cDataSlot.attr("assigned","1");
		return true;
	},
	onScroll: function(sC,eC,scrollData){
		((_.isNull(sC))?sC=function(){}:null);
		((_.isNull(eC))?eC=function(){}:null);

		var self = this;
		var cViewport = scrollData.viewport;
		var viewTolerance = 50;

		var cPage = self.page.get();

		_.forEach(self.slotData,function(cSlot,slotPos){
			if (cSlot.status){
				return;
			}

			if ((cSlot.domPos-scrollData.top-viewTolerance) <= cViewport || device.platform.toLowerCase() == 'ios'){
				self.loadDataSlot(slotPos);
			}
		});
		sC();
	},
	getInspireDataFor: function(inspireId){
		var self = this;
		
		if (!_.isUndefined(self.inspireData[inspireId])){
			return self.inspireData[inspireId];
		}
		return null;
	}
};