model = {
	tmpData: {

	},
	onLoad: function(sC,eC){
		var self = this;
		var cPage = self.page.get();

		app.api.doAPIRequestAsync(
			':api',
			'inspiration_sources',
			{limit: 16},
			'get',
			function(result){
				if(result.result===true){
					self.tmpData = result.data;
					sC();
				}
				else{
					if(result.result===false){
						app.nav.alert.show($.t('inspire.messages.errorUnknownError'),'error');
					}
					else{
						app.nav.alert.show($.t('inspire.messages.noProductsFound'),'info');
					}
					self.page.remove();
					eC();
				}
			},
			function(result){
				if(result.statusText=="timeout"){
					app.nav.alert.show($.t('inspire.messages.errorUnknownError'),'error');
				}
				self.page.remove();
				eC();
			}
		);
	},
	onFocus: function(sC,eC){
		var self = this;
		models("#header").changeHeader('logo_show');
		models("#footer").data.activeTab("star");
		sC();
	},
	onBlur: function(sC,eC){
		var self = this;
		sC();
	},
	afterShow: function(sC,eC){
		var self = this;

		var remainingPages = {
			'#startup':true,
			'#header':true,
			'#footer':true,
			'#filter':true,
			'#share':true
		};
		remainingPages[self.id()]=true;
		app.nav.showContainer('loading', true);
		app.nav.history.remove(
			remainingPages,
			function(succ){
				app.nav.hideContainer('loading');
				_(self.tmpData).forEach(function(cObj, cKey){
					self.prepareSlot(cKey, cObj);
				});
				sC();
			}
		);
	},
	prepareSlot: function(slotPos, cElement){
		var self = this;
		var cPage = self.page.get();

		var cDataSlot = cPage.find("[data-slot='"+slotPos+"']");

		// format topic
		var newName = '';
		var cNameLength = cElement.name.length;
		// these slots are 100% width
		if(slotPos==2 || slotPos==7 || slotPos==10 || slotPos==13){
			if(cNameLength>25){
				//letztes leerzeichen in der ersten zeile wird gesucht
				var llz_z1 = cElement.name.substr(0,25).lastIndexOf(' ');
				if(llz_z1!=(-1)){
					newName = cElement.name.substr(0,llz_z1) + '<br />' + cElement.name.substr(llz_z1+1);
					cDataSlot.find('.title-vertical').addClass('two-lines');
				}
				else{
					//erstes leerzeichen in der zweiten zeile wird gesucht
					var llz_z1 = cElement.name.substr(25,25).indexOf(' ');
					if(llz_z1!=(-1)){
						cDataSlot.find('.title-vertical').addClass('two-lines');
					}
					newName = cElement.name;
				}
			}
			else{
				newName = cElement.name;
			}
		}
		// these slots are 50% width
		else{
			if(cNameLength>12){
				var lastBindeStrich_z1 = cElement.name.trim().substr(0,12).lastIndexOf('-');
				var lastBindeStrich_z2 = cElement.name.trim().substr(12,13).indexOf('-');
				var llz_z1 = cElement.name.trim().substr(0,12).lastIndexOf(' ');
				var llz_z2 = cElement.name.trim().substr(12,13).indexOf(' ');
				if(lastBindeStrich_z1!=(-1) || lastBindeStrich_z2!=(-1)){
					if(lastBindeStrich_z1!=(-1)){
						newName = cElement.name.substr(0,lastBindeStrich_z1+1) + '<br />' + cElement.name.substr(lastBindeStrich_z1+1);
						cDataSlot.find('.title-vertical').addClass('two-lines');
					}
					else{
						if(lastBindeStrich_z2!=(-1)){
							cDataSlot.find('.title-vertical').addClass('two-lines');
						}
						newName = cElement.name;
					}
				}
				else{
					if(llz_z1!=(-1)){
						newName = cElement.name.substr(0,llz_z1) + '<br />' + cElement.name.substr(llz_z1+1);
						cDataSlot.find('.title-vertical').addClass('two-lines');
					}
					else{
						if(llz_z2!=(-1)){
							cDataSlot.find('.title-vertical').addClass('two-lines');
						}
						newName = cElement.name;
					}
				}
			}
			else{
				newName = cElement.name;
			}
		}

		cDataSlot.click(function(){
			app.nav.loadPage('#inspireLvl3', {id:cElement.id});
		});

		// set topic
		cDataSlot.find('h2').html(newName);
			
		cImage = cDataSlot.find('img');
		$(cImage).load(function(){
			$(this).closest('.outer-box').addClass("transition-fade-box-in").removeClass('transition-fade-box-out');
			//$(this).fadeIn({duration:2000});
			//$(this).css('display', 'block');
		});
		cImage.attr('src','http:'+cElement.image_url);
	}
};