model = {
	onLoad: function(sC, eC){
		if(!app.nav.page.is.loadedPage("#header")){
			app.nav.loadPage("#header",{pageLvl:1,noHistory: true},function(){
				models("#header").changeHeader('basket_hide');
				models("#header").changeHeader('text', $.t('onboarding.signUp'));
				sC();
			});
		}
		else{
			sC();
		}
	},
	onFocus: function(sC, eC){
		app.nav.showLevel(1);
		models("#header").changeHeader('basket_hide');
		models("#header").changeHeader('text', $.t('onboarding.signUp'));
		sC();
	},
	validateInput: function(cObj){
		if($(cObj).attr("data-type")=='email_username'){
			var re = /[\s\S]{3,}/;
		}
		if($(cObj).attr("data-type")=='email'){
			var re = /[\s\S]{1,}@[\s\S]{2,}.[a-z]{2,}/;
		}
		else if($(cObj).attr("data-type")=='password'){
			var re = /[\s\S]{5,}/;
		}
		else if($(cObj).attr("data-type")=='username'){
			var re = /[a-zA-Z0-9\-_]{3,40}/;
		}
		else if($(cObj).attr("data-type")=='firstname' || $(cObj).attr("data-type")=='lastname'){
			var re = /[\s\S]{1,}/;
		}
		else{
			var re;
		}
		valid = re.test(cObj.value);

		if(valid){
			$(cObj).parent().removeClass('error').addClass('succsess').children('i:first').css({'display':'block'}).removeClass('icon-exclamation-mark-bullet').addClass('icon-check-bullet');
		}
		else{
			$(cObj).parent().removeClass('succsess').addClass('error').children('i:first').css({'display':'block'}).removeClass('icon-check-bullet').addClass('icon-exclamation-mark-bullet');
		}
		console.log(valid);
		return valid;
	},
	validateCheckbox: function(){
		var self = this;
		var cPage = self.page.get();
		var valid = !(_.isUndefined(cPage.find('#signup_input_newsletter:checked').val()));
		if(!valid){
			cPage.find('#signup_input_newsletter').parent().parent().addClass('error');
			cPage.find('.error-text').css({'display':'block'});
		}
		else{
			cPage.find('#signup_input_newsletter').parent().parent().removeClass('error');
			cPage.find('.error-text').css({'display':'none'});
		}
		return valid;
	},
	scrollToDown: function(){
		var self = this;
		var cPage = self.page.get();
		var iW = cPage.find('.content-container');
		if(device.platform.toLowerCase()=='android'){
			iW.animate({scrollTop:(iW.scrollTop()+200)});
		}
		else{
			iW.animate({scrollTop:(iW.scrollTop()+250)});
		}
	},
	signUp: function(){
		var self = this;
		var cPage = self.page.get();
		var username = cPage.find('#signup_input_username').val();
		var emailaddress = cPage.find('#signup_input_email').val();
		var password = cPage.find('#signup_input_password').val();
		var forename = cPage.find('#signup_input_firstname').val();
		var surname = cPage.find('#signup_input_lastname').val();

		var inputValid1 = self.validateInput(cPage.find('#signup_input_username').get(0));
		var inputValid2 = self.validateInput(cPage.find('#signup_input_email').get(0));
		var inputValid3 = self.validateInput(cPage.find('#signup_input_password').get(0));
		var inputValid4 = self.validateInput(cPage.find('#signup_input_firstname').get(0));
		var inputValid5 = self.validateInput(cPage.find('#signup_input_lastname').get(0));
		var inputValid6 = self.validateCheckbox();
		if(inputValid1 && inputValid2 && inputValid3 && inputValid4 && inputValid5 && inputValid6){
			app.nav.showContainer('loading', true);
			self.signUpAPI(
				emailaddress,
				password,
				username,
				forename,
				surname,
				true,
				function(){
					analytics.trackEvent('Onboarding', 'register', null, 'DaWanda');
					var cLang = app.settings.get('LANGUAGE');
					if(device.platform.toLowerCase()=='android'){
						// adjust android register event
						if(cLang=='de'){
							Adjust.trackEvent('fwvm5g');
						}
						else if(cLang=='en'){
							Adjust.trackEvent('yfty4q');
						}
						else if(cLang=='es'){
							Adjust.trackEvent('ea872z');
						}
						else if(cLang=='fr'){
							Adjust.trackEvent('ltd66g');
						}
						else if(cLang=='it'){
							Adjust.trackEvent('o47sqz');
						}
						else if(cLang=='nl'){
							Adjust.trackEvent('daq5mh');
						}
						else if(cLang=='pl'){
							Adjust.trackEvent('dfipvg');
						}
					}
					else if(device.platform.toLowerCase()=='ios'){
						// adjust ios regsiter event
						if(cLang=='de'){
							Adjust.trackEvent('uszgjx');
						}
						else if(cLang=='en'){
							Adjust.trackEvent('qzekkx');
						}
						else if(cLang=='es'){
							Adjust.trackEvent('jv1ux4');
						}
						else if(cLang=='fr'){
							Adjust.trackEvent('e6df2s');
						}
						else if(cLang=='it'){
							Adjust.trackEvent('q5qh9z');
						}
						else if(cLang=='nl'){
							Adjust.trackEvent('ba83ha');
						}
						else if(cLang=='pl'){
							Adjust.trackEvent('jt5fwo');
						}
					}
					app.settings.set('api.userLoggedIn', true, true);
					app.settings.set('api.userName', username, true);
					app.settings.set('api.userEmail', emailaddress, true);
					cPage.find('#signup_input_username').val('').parent().removeClass('error succsess').children('i:first').css({'display':'none'}).removeClass('icon-check-bullet icon-exclamation-mark-bullet');
					cPage.find('#signup_input_email').val('').parent().removeClass('error succsess').children('i:first').css({'display':'none'}).removeClass('icon-check-bullet icon-exclamation-mark-bullet');
					cPage.find('#signup_input_password').val('').parent().removeClass('error succsess').children('i:first').css({'display':'none'}).removeClass('icon-check-bullet icon-exclamation-mark-bullet');
					cPage.find('#signup_input_firstname').val('').parent().removeClass('error succsess').children('i:first').css({'display':'none'}).removeClass('icon-check-bullet icon-exclamation-mark-bullet');
					cPage.find('#signup_input_lastname').val('').parent().removeClass('error succsess').children('i:first').css({'display':'none'}).removeClass('icon-check-bullet icon-exclamation-mark-bullet');
					app.nav.loadPage('#onboardingValidateEmail', {noHistory: true}, function(){
						app.nav.history.clear();
					});
				},
				function(){
					app.nav.hideContainer('loading');
				}
			);
		}
	},
	signUpAPI: function(emailaddress, password, username, forename, surname, receive_newsletter, sC, eC){
		var self = this;
		var cPage = self.page.get();
		app.api.doAPIRequestAsync(
			':apiRegisterDW',
			'registrations',
			{'registration':{'email':emailaddress, 'password':password, 'username':username, 'firstname':forename, 'lastname':surname, 'receive_newsletter':receive_newsletter, 'platform':app.settings.get('LANGUAGE'), 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':true}},
			//{'registration':{'email':emailaddress, 'password':password, 'username':username, 'firstname':forename, 'lastname':surname, 'receive_newsletter':receive_newsletter, platform:'de'}},
			'post',
			function(result){
				console.log(result);
				if(result.result===true){
					sC();
				}
				else if((result.result===false && typeof result.data == 'number') || result.statusText=="timeout"){
					app.nav.alert.show($.t('onboarding.messages.errorUnknownError'),'error');
					eC(result);
				}
				else{
					if((!_.isNull(result.data)) && (!_.isUndefined(result.data.errors))){
						var error_array = [];
						if(!_.isUndefined(result.data.errors.email)){
							if(result.data.errors.email=='taken'){
								error_array.push($.t('onboarding.messages.errorEmailTaken'));
							}
							if(result.data.errors.email=='invalid'){
								error_array.push($.t('onboarding.messages.errorEmailInvalid'));
							}
							if(result.data.errors.email=='too_short'){
								error_array.push($.t('onboarding.messages.errorEmailTooShort'));
							}
							if(result.data.errors.email=='blank'){
								error_array.push($.t('onboarding.messages.errorEmailBlank'));
							}
							cPage.find('#signup_input_email').parent().addClass('error').children('i:first').removeClass('icon-check-bullet').addClass('icon-exclamation-mark-bullet');
						}
						if(!_.isUndefined(result.data.errors.password)){
							if(result.data.errors.password=='too_short'){
								error_array.push($.t('onboarding.messages.errorPasswordToShort'));
							}
							cPage.find('#signup_input_password').parent().addClass('error').children('i:first').removeClass('icon-check-bullet').addClass('icon-exclamation-mark-bullet');
						}
						if(!_.isUndefined(result.data.errors.username)){
							if(result.data.errors.username=='taken'){
								error_array.push($.t('onboarding.messages.errorUsernameTaken'));
							}
							if(result.data.errors.username=='invalid'){
								error_array.push($.t('onboarding.messages.errorUsernameInvalid'));
							}
							if(result.data.errors.username=='too_short'){
								error_array.push($.t('onboarding.messages.errorUsernameTooShort'));
							}
							if(result.data.errors.username=='blank'){
								error_array.push($.t('onboarding.messages.errorUsernameBlank'));
							}
							cPage.find('#signup_input_username').parent().addClass('error').children('i:first').removeClass('icon-check-bullet').addClass('icon-exclamation-mark-bullet');
						}
						if(!_.isUndefined(result.data.errors.firstname)){
							if(result.data.errors.firstname=='blank'){
								error_array.push($.t('onboarding.messages.errorFirstNameBlank'));
							}
							cPage.find('#signup_input_firstname').removeClass('icon-check-bullet').addClass('icon-exclamation-mark-bullet');
						}
						if(!_.isUndefined(result.data.errors.lastname)){
							if(result.data.errors.lastname=='blank'){
								error_array.push($.t('onboarding.messages.errorLastNameBlank'));
							}
							cPage.find('#signup_input_lastname').parent().addClass('error').children('i:first').removeClass('icon-check-bullet').addClass('icon-exclamation-mark-bullet');
						}
						app.nav.alert.show(error_array.join("<br />"), 'error');
						eC();
					}
					else{
						app.nav.alert.show($.t('onboarding.messages.errorUnknownError'),'error');
						eC();
					}
				}
			},
			function(){
				app.nav.alert.show($.t('onboarding.messages.errorUnknownError'),'error');
				eC();
			}
		);
	},
	loginFacebook: function(){
		var self = this;
		var cPage = self.page.get();
		self.loginFacebookAPI(
			function(result){
				app.nav.showContainer('loading', true);
				if(result.result===true){
					analytics.trackEvent('Onboarding', 'register', null, 'Facebook');
					app.settings.set("LANGUAGE",result.data.platform, true, function(){
						app.helper.nav.i18n.changeLng(result.data.platform,function(){
							var cLang = app.settings.get('LANGUAGE');
							if(device.platform.toLowerCase()=='android'){
								// adjust android facebook connect event
								if(cLang=='de'){
									Adjust.trackEvent('64jjcw');
								}
								else if(cLang=='en'){
									Adjust.trackEvent('ulm3iz');
								}
								else if(cLang=='es'){
									Adjust.trackEvent('it0xxg');
								}
								else if(cLang=='fr'){
									Adjust.trackEvent('n0e41r');
								}
								else if(cLang=='it'){
									Adjust.trackEvent('1p3324');
								}
								else if(cLang=='nl'){
									Adjust.trackEvent('73fhyi');
								}
								else if(cLang=='pl'){
									Adjust.trackEvent('t23s20');
								}
							}
							else if(device.platform.toLowerCase()=='ios'){
								// adjust ios facebook connect event
								if(cLang=='de'){
									Adjust.trackEvent('686ltr');
								}
								else if(cLang=='en'){
									Adjust.trackEvent('ldbv48');
								}
								else if(cLang=='es'){
									Adjust.trackEvent('2x33q2');
								}
								else if(cLang=='fr'){
									Adjust.trackEvent('kwp8xx');
								}
								else if(cLang=='it'){
									Adjust.trackEvent('2sin8x');
								}
								else if(cLang=='nl'){
									Adjust.trackEvent('nn22bn');
								}
								else if(cLang=='pl'){
									Adjust.trackEvent('u7639c');
								}
							}
							app.settings.set('api.userLoggedIn', true, true);
							if(app.nav.page.is.loadedPage("#header")){
								models('#header').page.refreshLng();
							}
							if(app.settings.get("pn.hasBeenAsked")===true){
								models('#startup').onboardingSuccess(function(){});
							}
							else{
								app.nav.loadPage('#onboardingPNSettings',{noHistory: true},function(){
									app.nav.history.clear();
								});
							}
						});
					});
				}
				else if(result.result===false && (!_.isUndefined(result.data.errors)) && (!_.isUndefined(result.data.errors.terms))){
					app.nav.loadPage('#onboardingSignupFacebook', {'referrer':'register'});
				}
				else if(result.result===false){
					app.nav.hideContainer('loading');
					app.nav.alert.show($.t('onboarding.messages.errorFacebookLogin'),'error');
				}
				else{
					app.nav.hideContainer('loading');
					app.nav.alert.show($.t('onboarding.messages.errorUnknownErrorFacebookLogin'),'error');
				}
			},
			function(){
				app.nav.hideContainer('loading');
				app.nav.alert.show($.t('onboarding.messages.errorFacebookLogin'),'error');
			}
		);
	},
	loginFacebookAPI: function(sC, eC){
		facebookConnectPlugin.getLoginStatus(
			function(succ){
				if(succ.status=='connected'){
					// if status is connected
					facebookConnectPlugin.api(
						'/me/permissions',
						[],
						function(result1){
							// result1 = object with current permissions, need to check if enough
							var necessaryPermissions = new Array('email');
							_(result1.data).forEach(function(cElement){
								var index = necessaryPermissions.indexOf(cElement.permission);
								if(index > -1){
									necessaryPermissions.splice(index, 1);
								}
							});
							// if more than given perms needed
							if(necessaryPermissions.length>0){
								facebookConnectPlugin.api(
									'/me/permissions',
									necessaryPermissions,
									function(result2){
										// result2 = new Permission Object with all Perms needed (object is not needed)
										facebookConnectPlugin.getAccessToken(
											function(result3){
												// result3 = AccessToken
												app.api.doAPIRequestAsync(
													':apiLoginFB',
													'facebook_connections',
													{'facebook_connection':{'access_token':result3, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':false, 'receive_newsletter':false}},
													'post',
													function(result4){
														// result4 is true if login ok, else false
														sC(result4);
													},
													function(err){
														// ERROR
														console.error(err);
														eC();
													}
												);
											},
											function(err){
												// ERROR
												console.error(err);
												eC();
											}
										);
									},
									function(err){
										// ERROR
										console.error(err);
										eC();
									}
								);
							}
							// if all needed perms are given
							else{
								facebookConnectPlugin.getAccessToken(
									function(result2){
										// result2 = AccessToken
										app.api.doAPIRequestAsync(
											':apiLoginFB',
											'facebook_connections',
											{'facebook_connection':{'access_token':result2, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':false, 'receive_newsletter':false}},
											'post',
											function(result3){
												// result3 is true if login ok, else false
												sC(result3);
											},
											function(err){
												// ERROR
												console.error(err);
												eC();
											}
										);
									},
									function(err){
										// ERROR
										console.error(err);
										eC();
									}
								);
							}
						},
						function(err){
							// ERROR
							// this function is fired if user deletes dawanda permission on facebook
							//alert('Sie haben DaWanda auf Facebook die App-Berechtigung entzogen, bitte neu einloggen!');
							console.error(err);
							facebookConnectPlugin.login(
								new Array('email'),
								function(succ){
									facebookConnectPlugin.getAccessToken(
										// result1 = AccessToken
										function(result1){
											app.api.doAPIRequestAsync(
												':apiLoginFB',
												'facebook_connections',
												{'facebook_connection':{'access_token':result1, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':false, 'receive_newsletter':false}},
												'post',
												function(result2){
													// result2 is true if login ok, else false
													sC(result2);
												},
												function(err){
													// ERROR
													console.error(err);
													eC();
												}
											);
										},
										function(err){
											// ERROR
											console.error(err);
											eC();
										}
									);
								},
								function(err){
									// ERROR
									console.error(err);
									eC();
								}
							);
						}
					);
				}
				else{
					// if status is NOT connected
					facebookConnectPlugin.login(
						new Array('email'),
						function(succ){
							facebookConnectPlugin.getAccessToken(
								// result1 = AccessToken
								function(result1){
									app.api.doAPIRequestAsync(
										':apiLoginFB',
										'facebook_connections',
										{'facebook_connection':{'access_token':result1, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':false, 'receive_newsletter':false}},
										'post',
										function(result2){
											// result2 is true if login ok, else false
											sC(result2);
										},
										function(err){
											// ERROR
											console.error(err);
											eC();
										}
									);
								},
								function(err){
									// ERROR
									console.error(err);
									eC();
								}
							);
						},
						function(err){
							// ERROR
							console.error(err);
							eC();
						}
					);
				}
			},
			function(err){
				// ERROR
				console.error(err);
				eC();
			}
		);
	}
}