model = {
	onLoad: function(sC, eC){
		if(!app.nav.page.is.loadedPage("#header")){
			app.nav.loadPage("#header",{pageLvl:1,noHistory: true},function(){
				models("#header").changeHeader('basket_hide');
				models("#header").changeHeader('text', $.t('onboarding.signUp'));
				sC();
			});
		}
		else{
			sC();
		}
	},
	onFocus: function(sC, eC){
		app.nav.showLevel(1);
		models("#header").changeHeader('basket_hide');
		models("#header").changeHeader('text', $.t('onboarding.signUp'));
		sC();
	},
	validateCheckbox: function(){
		var self = this;
		var cPage = self.page.get();
		var valid = !(_.isUndefined(cPage.find('#signup_terms_facebook:checked').val()));
		if(!valid){
			cPage.find('#signup_terms_facebook').parent().parent().addClass('error');
			cPage.find('.error-text').css({'display':'block'});
		}
		else{
			cPage.find('#signup_terms_facebook').parent().parent().removeClass('error');
			cPage.find('.error-text').css({'display':'none'});
		}
		return valid;
	},
	loginFacebook: function(){
		var self = this;
		var cPage = self.page.get();
		var inputValid1 = self.validateCheckbox();
		if(inputValid1){
			self.loginFacebookAPI(
				function(result){
					app.nav.showContainer('loading', true);
					if(result.result===true){
						analytics.trackEvent('Onboarding', 'login', null, 'Facebook');
						app.settings.set("LANGUAGE",result.data.platform, true, function(){
							app.helper.nav.i18n.changeLng(result.data.platform,function(){
								var cLang = app.settings.get('LANGUAGE');
								if(self.params.get('referrer')=='register'){
									if(device.platform.toLowerCase()=='android'){
										// adjust android register event
										if(cLang=='de'){
											Adjust.trackEvent('fwvm5g');
										}
										else if(cLang=='en'){
											Adjust.trackEvent('yfty4q');
										}
										else if(cLang=='es'){
											Adjust.trackEvent('ea872z');
										}
										else if(cLang=='fr'){
											Adjust.trackEvent('ltd66g');
										}
										else if(cLang=='it'){
											Adjust.trackEvent('o47sqz');
										}
										else if(cLang=='nl'){
											Adjust.trackEvent('daq5mh');
										}
										else if(cLang=='pl'){
											Adjust.trackEvent('dfipvg');
										}
									}
									else if(device.platform.toLowerCase()=='ios'){
										// adjust ios regsiter event
										if(cLang=='de'){
											Adjust.trackEvent('uszgjx');
										}
										else if(cLang=='en'){
											Adjust.trackEvent('qzekkx');
										}
										else if(cLang=='es'){
											Adjust.trackEvent('jv1ux4');
										}
										else if(cLang=='fr'){
											Adjust.trackEvent('e6df2s');
										}
										else if(cLang=='it'){
											Adjust.trackEvent('q5qh9z');
										}
										else if(cLang=='nl'){
											Adjust.trackEvent('ba83ha');
										}
										else if(cLang=='pl'){
											Adjust.trackEvent('jt5fwo');
										}
									}
								}
								else if(self.params.get('referrer')=='login'){
									if(device.platform.toLowerCase()=='android'){
										// adjust android facebook connect event
										if(cLang=='de'){
											Adjust.trackEvent('64jjcw');
										}
										else if(cLang=='en'){
											Adjust.trackEvent('ulm3iz');
										}
										else if(cLang=='es'){
											Adjust.trackEvent('it0xxg');
										}
										else if(cLang=='fr'){
											Adjust.trackEvent('n0e41r');
										}
										else if(cLang=='it'){
											Adjust.trackEvent('1p3324');
										}
										else if(cLang=='nl'){
											Adjust.trackEvent('73fhyi');
										}
										else if(cLang=='pl'){
											Adjust.trackEvent('t23s20');
										}
									}
									else if(device.platform.toLowerCase()=='ios'){
										// adjust ios facebook connect event
										if(cLang=='de'){
											Adjust.trackEvent('686ltr');
										}
										else if(cLang=='en'){
											Adjust.trackEvent('ldbv48');
										}
										else if(cLang=='es'){
											Adjust.trackEvent('2x33q2');
										}
										else if(cLang=='fr'){
											Adjust.trackEvent('kwp8xx');
										}
										else if(cLang=='it'){
											Adjust.trackEvent('2sin8x');
										}
										else if(cLang=='nl'){
											Adjust.trackEvent('nn22bn');
										}
										else if(cLang=='pl'){
											Adjust.trackEvent('u7639c');
										}
									}
								}
								app.settings.set('api.userLoggedIn', true, true);
								if(app.nav.page.is.loadedPage("#header")){
									models('#header').page.refreshLng();
								}
								if(app.settings.get("pn.hasBeenAsked")===true){
									models('#startup').onboardingSuccess(function(){});
								}
								else{
									app.nav.loadPage('#onboardingPNSettings',{noHistory: true},function(){
										app.nav.history.clear();
									});
								}
							});
						});
					}
					else if(result.result===false){
						app.nav.hideContainer('loading');
						app.nav.alert.show($.t('onboarding.messages.errorFacebookLogin'),'error');
					}
					else{
						app.nav.hideContainer('loading');
						app.nav.alert.show($.t('onboarding.messages.errorUnknownErrorFacebookLogin'),'error');
					}
				},
				function(){
					//cPage.find('.button-container').children('button').prop("disabled", false).removeClass('btn-grey medium-button-grey').addClass('btn-green medium-button-green');
					//self.page.getLoading().addClass("hidden");
					app.nav.hideContainer('loading');
					app.nav.alert.show($.t('onboarding.messages.errorFacebookLogin'),'error');
				}
			);
		}
	},
	loginFacebookAPI: function(sC, eC){
		facebookConnectPlugin.getLoginStatus(
			function(succ){
				if(succ.status=='connected'){
					// if status is connected
					facebookConnectPlugin.api(
						'/me/permissions',
						[],
						function(result1){
							// result1 = object with current permissions, need to check if enough
							var necessaryPermissions = new Array('email');
							_(result1.data).forEach(function(cElement){
								var index = necessaryPermissions.indexOf(cElement.permission);
								if(index > -1){
									necessaryPermissions.splice(index, 1);
								}
							});
							// if more than given perms needed
							if(necessaryPermissions.length>0){
								facebookConnectPlugin.api(
									'/me/permissions',
									necessaryPermissions,
									function(result2){
										// result2 = new Permission Object with all Perms needed (object is not needed)
										facebookConnectPlugin.getAccessToken(
											function(result3){
												// result3 = AccessToken
												app.api.doAPIRequestAsync(
													':apiLoginFB',
													'facebook_connections',
													{'facebook_connection':{'access_token':result3, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':true, 'receive_newsletter':true}},
													'post',
													function(result4){
														// result4 is true if login ok, else false
														sC(result4);
													},
													function(err){
														// ERROR
														console.error(err);
														eC();
													}
												);
											},
											function(err){
												// ERROR
												console.error(err);
												eC();
											}
										);
									},
									function(err){
										// ERROR
										console.error(err);
										eC();
									}
								);
							}
							// if all needed perms are given
							else{
								facebookConnectPlugin.getAccessToken(
									function(result2){
										// result2 = AccessToken
										app.api.doAPIRequestAsync(
											':apiLoginFB',
											'facebook_connections',
											{'facebook_connection':{'access_token':result2, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':true, 'receive_newsletter':true}},
											'post',
											function(result3){
												// result3 is true if login ok, else false
												sC(result3);
											},
											function(err){
												// ERROR
												console.error(err);
												eC();
											}
										);
									},
									function(err){
										// ERROR
										console.error(err);
										eC();
									}
								);
							}
						},
						function(err){
							// ERROR
							// this function is fired if user deletes dawanda permission on facebook
							//alert('Sie haben DaWanda auf Facebook die App-Berechtigung entzogen, bitte neu einloggen!');
							console.error(err);
							facebookConnectPlugin.login(
								new Array('email'),
								function(succ){
									facebookConnectPlugin.getAccessToken(
										// result1 = AccessToken
										function(result1){
											app.api.doAPIRequestAsync(
												':apiLoginFB',
												'facebook_connections',
												{'facebook_connection':{'access_token':result1, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':true, 'receive_newsletter':true}},
												'post',
												function(result2){
													// result2 is true if login ok, else false
													sC(result2);
												},
												function(err){
													// ERROR
													console.error(err);
													eC();
												}
											);
										},
										function(err){
											// ERROR
											console.error(err);
											eC();
										}
									);
								},
								function(err){
									// ERROR
									console.error(err);
									eC();
								}
							);
						}
					);
				}
				else{
					// if status is NOT connected
					facebookConnectPlugin.login(
						new Array('email'),
						function(succ){
							facebookConnectPlugin.getAccessToken(
								// result1 = AccessToken
								function(result1){
									app.api.doAPIRequestAsync(
										':apiLoginFB',
										'facebook_connections',
										{'facebook_connection':{'access_token':result1, 'remember_me':true, 'partner':app.settings.get('LANGUAGE')+'_mobapp', 'terms':true, 'receive_newsletter':true}},
										'post',
										function(result2){
											// result2 is true if login ok, else false
											sC(result2);
										},
										function(err){
											// ERROR
											console.error(err);
											eC();
										}
									);
								},
								function(err){
									// ERROR
									console.error(err);
									eC();
								}
							);
						},
						function(err){
							// ERROR
							console.error(err);
							eC();
						}
					);
				}
			},
			function(err){
				// ERROR
				console.error(err);
				eC();
			}
		);
	}
}