model = {
	onLoad: function(sC,eC){
		var self = this;
		var cPage = self.page.get();

		cId = self.params.get('id');
		refPageId = self.params.get('refPageId');

		app.api.doAPIRequestAsync(
			':api',
			'product_seller_details/' + cId,
			{},
			'get',
			function(result){
				if(result.result===true){
					self.data.pdpData = result.data;
					self.data.pdpData.description_title = self.params.get('description_title');
					self.data.pdpData.description_image = self.params.get('description_image');
					self.data.pdpData.seller_username = self.params.get('seller_username');
					self.data.pdpData.seller_avatar = self.params.get('seller_avatar');
					self.data.pdpData.availability_max = self.params.get('availability_max');

					self.data.pdpData.seller.shop.imprint = formatString(self.data.pdpData.seller.shop.imprint);
					self.data.pdpData.seller.shop.terms = formatString(self.data.pdpData.seller.shop.terms);
					self.data.pdpData.seller.shop.cancellation = formatString(self.data.pdpData.seller.shop.cancellation);

					if(self.data.pdpData.return_policy!=null){
						self.data.pdpData.return_policy.text = formatString(self.data.pdpData.return_policy.text);
					}

					self.data.pdpData.pdpShippingPaymentOnClickFunction = function(){
						app.nav.loadPage(
							'#pdpShippingPayment',
							{
								'id':cId,
								'refPageId':refPageId,
								'description_title':self.data.pdpData.description_title,
								'description_image':self.data.pdpData.description_image,
								'seller_username':self.data.pdpData.seller_username,
								'seller_avatar':self.data.pdpData.seller_avatar,
								'availability_max':self.data.pdpData.availability_max
							}
						);
					}
					self.data.pdpData.pdpProductImprintTermsReturnsOnClickFunction = function(){
						app.nav.loadPage(
							'#pdpProductImprintTermsReturns',
							{
								'id':cId,
								'refPageId':refPageId,
								'description_title':self.data.pdpData.description_title,
								'description_image':self.data.pdpData.description_image,
								'seller_username':self.data.pdpData.seller_username,
								'seller_avatar':self.data.pdpData.seller_avatar,
								'availability_max':self.data.pdpData.availability_max
							}
						);
					}

					sC();
				}
				else{
					app.nav.alert.show($.t('pdp.messages.errorUnknownError'),'error');
					self.page.remove();
					eC();
				}
			},
			eC
		);
	},
	onFocus: function(sC,eC){
		var self = this;
		self.toggleHeadContainer(true);
		sC();
	},
	onBlur: function(sC,eC){
		var self = this;
		self.toggleHeadContainer(false);
		sC();
	},
	toggleHeadContainer: function(showHeader){
		var self = this;

		if (showHeader){
			models("#header").changeHeader('text', $.t('pdp.imprintTCReturns'));
		}
		else{
			models("#header").changeHeader('logo');
		}		
	},
	addToCart: function(){
		var self = this;
		var cPage = self.page.get();
		var cId = self.params.get("id");
		var quantity = 1;
		var cAvailability = self.data.pdpData.availability_max;
		app.api.doAPIRequestAsync(
			':api',
			'cart_items',
			{},
			'get',
			function(result){
				_(result.data).forEach(function(cElement){
					if(cElement.product_id==cId){
						cAvailability = cAvailability-cElement.quantity;
					}
				});
				if(cAvailability>0){
					app.api.doAPIRequestAsync(
						':apiPost',
						'cart_items',
						{'cart_item':{'product_id':cId, 'quantity':quantity}},
						'post',
						function(result2){
							if(result2.result===true){
								analytics.trackEvent('Cart', 'added-to-cart', null, cId);
								var cLang = app.settings.get('LANGUAGE');
								if(device.platform.toLowerCase()=='android'){
									// adjust android add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('m3b3c1');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('nbhx7d');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('mlhmsu');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('prrwuy');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('si2sxy');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('1zduhl');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('wqzphj');
									}
								}
								else if(device.platform.toLowerCase()=='ios'){
									// adjust ios add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('bq1h8u');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('k8g1a5');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('spud5p');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('coo8mt');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('poong4');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('fegcf0');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('ql6psr');
									}
								}
								app.nav.alert.show($.t('pdp.messages.successAddedToCart'));
								app.api.doAPIRequestAsync(
									':api',
									'cart_items/count',
									{},
									'get',
									function(result3){
										if(result3.result===true){
											app.system.cartCountValue(result3.data);
										}
									},
									function(){
										app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
									}
								);
							}
							else{
								app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
							}
						},
						function(){
							app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
						}
					);
				}
				else{
					app.nav.alert.show($.t('pdp.messages.errorMaxAvailInCart'), 'error');
				}
			},
			function(){
				app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
			}
		);
	}
};