model = {
	// definitions
	_def: {
		itemsPerPage: 20,
		page: 1,
		slotTolerance: 50,
		slotDefaultHeight: 200,
		scrollBottomTolerance: 600
	},
	onLoad: function(sC,eC){
		//document.addEventListener('touchstart', function() {},false);
		var self = this;
		var cPage = self.page.get();

		/*********************************
		 * BLOCK FOR RECOMMANDATION-LIST *
		 *********************************/

		// prepare scroll-bottom-distance
		self.func.set("scroll-bottom-tolerance",self._def.scrollBottomTolerance);

		// set observableData
		self.data.recommandationSourcesColumnLeft = ko.observableArray();
		self.data.recommandationSourcesColumnRight = ko.observableArray();

		// this is the refresher var for all DOM events
		self.computedRefresher = ko.observable(0);

		// the temporary stored products from the api
		self.tempProductList = [];

		// slot position-data || {domPos: 1234, status: false, id: null}
		self.slotData = {};

		// this is a var to stop bottomScroll loading (used, if no more products available)
		self.productLoadStatus = true;

		// this is a var, to prevent double-bottom(in/out) scroll and load data multiple times
		self.productLoadHold = false;

		// this is the computed function for all new elements
		self.computedProductList = ko.computed(function(){
			var _x = self.computedRefresher();

			var _tmp = self.getSmallerColumn();

			var cPos = _tmp.start;
			var startCount = 0;
			var startAmount = _tmp.amount;
			var startUse = _tmp.use;
			_(self.tempProductList).forEach(function(preProduct){
				if (startCount < startAmount){
					if (startUse == 'left'){
						self.data.recommandationSourcesColumnLeft.push(preProduct);
					}else{
						self.data.recommandationSourcesColumnRight.push(preProduct);
					}
					startCount++;
					return;
				}

				if (cPos%2==0){
					self.data.recommandationSourcesColumnLeft.push(preProduct);
				}else{
					self.data.recommandationSourcesColumnRight.push(preProduct);
				}
				cPos++;
			});
			// clean product list
			self.tempProductList = [];

			// hide-show noResults & loadingContainer container
			if (self.productLoadStatus == false){
				// hide loadingContainer
				self.page.getLoading().addClass("hidden");
			}else{
				// show loading container
				/*if(self.page.getLoading().hasClass("center")){
					self.page.getLoading().removeClass("center");
				}*/
				self.page.getLoading().removeClass("hidden");
			}		
		});


		/**********************
		 * BLOCK FOR OVERVIEW *
		 **********************/

		var cId = self.params.get("id");

		self.data.cMId = self.id();
		
		cPage.find('.pdp-slider-container').css({'height':cPage.find('.pdp-slider-container').width() / 4 * 3});

		app.api.doAPIRequestAsync(
			':api',
			'product_details/' + cId,
			{},
			'get',
			function(result){
				if(result.result===true){
					self.data.pdpData = self.buildCurrentContainer(result.data);
					sC();
				}
				else{
					app.nav.alert.show($.t('pdp.messages.errorUnknownError'),'error');
					self.page.remove();
					eC();
				}
			},
			eC
		);
		// IMAGES VORLADEN!!!
	},
	onFocus: function(sC,eC){
		var self = this;
		sC();
	},
	onBlur: function(sC,eC){
		var self = this;
		sC();
	},
	afterShow: function(sC,eC,eParams){
		var self = this;

		if (eParams.firstCall){
			self.onScrollBottom(sC,eC);
		}else{
			sC();
		}
	},
	onScrollBottom: function(sC,eC,sData){
		((!sC)?sC=function(){}:null);
		((!eC)?eC=function(){}:null);
		((!sData)?sData={}:null);
		var self = this;

		// check if more products are empty
		if (!self.productLoadStatus){
			sC();
			return;
		}

		// check pHold
		if (self.productLoadHold){
			sC();
			return;
		}
		// set pHold
		self.productLoadHold = true;

		// show loadingContainer
		self.page.getLoading().removeClass("hidden");

		var _loadAPI = function(){
			// get products from API
			self.getDataFromAPI(
				function(iData){
					// refresh list now
					self.computedRefresher(self.computedRefresher()+1);

					// workaround for iOS devices
					self.loadAllDataSlots();
					self.productLoadHold = false;
					sC();
				},
				function(result){
					if(result.result===false || result.statusText=="timeout"){
						app.nav.alert.show($.t('pdp.messages.errorUnknownError'),'error');
					}
					// workaround for iOS devices
					self.loadAllDataSlots();
					self.productLoadHold = false;
					sC();
				}
			);
		};

		window.setTimeout(function(){
			_loadAPI();
		},250);
	},
	loadAllDataSlots: function(){
		var self = this;
		_.forEach(self.slotData,function(cSlot,slotId){
			self.loadDataSlot(slotId);
		});
	},
	loadDataSlot: function(slotId){
		var self = this;
		var cPage = self.page.get();
		var dImg = cPage.find("[data-img='"+slotId+"']");
		var slotData = self.slotData[slotId];
		if (dImg.length > 0 && slotData.img != ""){
			dImg.attr("src",slotData.img);
			delete self.slotData[slotId];
		}
	},
	getDataFromAPI: function(sC,eC){
		((!eC)?eC=function(){}:null);
		var self = this;

		var rParams = {
			page: self._def.page,
			per_page: self._def.itemsPerPage,
		};

		app.api.doAPIRequestAsync(
			':api',
			'recommendations_for_product/' + self.params.get("id"),
			rParams,
			'get',
			function(result){
				if(result.result===true){
					var iData = result.data;
					self._def.page++;

					// check for valid result
					if (iData && iData.length > 0){
						_(iData).forEach(function(cProduct){
							var pProduct = self.prepareProduct(cProduct);
							self.tempProductList.push(pProduct);
							self.slotData[cProduct.id] = {domPos: null,id:pProduct.id,img: pProduct.image};
						});

						// check for max length reached
						if (iData.length < self._def.itemsPerPage){
							self.productLoadStatus = false;
						}
					}else{
						// prevent loading additional data
						self.productLoadStatus = false;
					}
					sC(iData);
				}
				else{
					eC(result);
				}
			},
			eC
		);
	},
	getSmallerColumn: function(){
		var self = this;
		var cPage = self.page.get();
		var leftColumnSize = cPage.find(".recommandation-listview .col-50:first").height();
		var rightColumnSize = cPage.find(".recommandation-listview .col-50:last").height();

		var useAmount = 0;
		var use = "left";
		var startPos = 0;

		if (leftColumnSize == rightColumnSize){
			// do nothing
		}else if(leftColumnSize > rightColumnSize){
			useAmount = Math.ceil((leftColumnSize-rightColumnSize)/self._def.slotDefaultHeight);
			use = "right";
			startPos = 0;
		}else{
			useAmount = Math.ceil((rightColumnSize-leftColumnSize)/self._def.slotDefaultHeight);
			startPos = 1;
		}
		return {'use': use, amount: useAmount, start: startPos};
	},
	prepareProduct: function(cProduct){
		var self = this;

		var cDataContainer = {
			id: cProduct.id,
			title: cProduct.title,
			avatar: ((cProduct.avatar)?"http:"+cProduct.avatar:"shared/img/mini-avatar.png"),
			image: 'http:'+cProduct.default_image.full,
			seller: cProduct.seller,
			pinned: app.system.checkProductOnPinnedProductsList(cProduct.id)
		};
		return cDataContainer;
	},
	calculateImageSliderSizes: function(cObj, force){
		if (($(cObj).attr("data-pos") != '0') && force != true){
			return false;
		}

		var self = window.model;

		var cImageWidth = $(cObj).width();
		var cImageHeight = $(cObj).height();
		var cImageRatio = cImageWidth / cImageHeight;
		var pdpSliderRange = $(cObj).closest(".slider-range");
		var pdpSliderContainer = $(cObj).closest(".pdp-slider-container");
		var pdpSliderList = $(cObj).closest(".pdp-slider-list");
		var pdpSliderElements = pdpSliderList.children();
		var pdpSliderImages = pdpSliderElements.children();

		pdpSliderContainer.css({'height':pdpSliderContainer.width() / cImageRatio});
		pdpSliderImages.each(function(){
			ccImageRatio = $(this).width() / $(this).height();
			$(this).css({'width':pdpSliderContainer.width(), 'height':pdpSliderContainer.width() / ccImageRatio, 'margin-top':(((pdpSliderContainer.width() / cImageRatio) - (pdpSliderContainer.width() / ccImageRatio)) / 2), 'margin-bottom':(((pdpSliderContainer.width() / cImageRatio) - (pdpSliderContainer.width() / ccImageRatio)) / 2)});
		});
		pdpSliderList.css({'width':(pdpSliderContainer.width()*pdpSliderElements.length), 'height':pdpSliderContainer.height()});

		// slider wird nur aktiviert, wenn mehr als 1 bild verfügbar ist
		if(pdpSliderElements.length>1){
			var hammertime = new Hammer(pdpSliderRange.get(0), {preventDefault: true});
			hammertime.get('swipe').set({ velocity: 0.01 });
			//hammertime.get("swipe").set({});
			hammertime.on('swipeleft', function(){
				self.slideLeft();
				console.log('swipeleft');
			});
			hammertime.on('swiperight', function(){
				self.slideRight();
				console.log('swiperight');
			});
		}
		else{
			pdpSliderRange.find('.pdp-slider-dot-container').css({display:'none'});
		}
		
	},
	slideLeft: function(){
		var self = window.model;
		var cPage = self.page.get();
		var cImageWidth = cPage.find('.pdp-slider-element:first').width();
		var cImageHeight = cPage.find('.pdp-slider-element:first').height();

		var firstItem = cPage.find('.pdp-slider-element:first');
		firstItem.children().css({'margin-left': cImageWidth*-1});
		setTimeout(function(){
			cPage.find('.pdp-slider-list').append(firstItem);
			firstItem.children().removeClass('pdp-slider-image-t').css({'margin-left': 0}).addClass('pdp-slider-image-t');
		}, 300);

		var lastDotItem = cPage.find('.pdp-slider-dot-element:last');
		cPage.find('.pdp-slider-dot-list').prepend(lastDotItem);
	},
	slideRight: function(){
		var self = window.model;
		var cPage = self.page.get();
		var cImageWidth = cPage.find('.pdp-slider-element:last').width();
		var cImageHeight = cPage.find('.pdp-slider-element:last').height();

		var lastItem = cPage.find('.pdp-slider-element:last');
		lastItem.children().removeClass('pdp-slider-image-t').css({'margin-left': cImageWidth*-1}).addClass('pdp-slider-image-t');
		cPage.find('.pdp-slider-list').prepend(lastItem);
		setTimeout(function(){
			lastItem.children().css({'margin-left': 0});
		}, 1);

		var firstDotItem = cPage.find('.pdp-slider-dot-element:first');
		cPage.find('.pdp-slider-dot-list').append(firstDotItem);
	},
	buildCurrentContainer: function(cDataSource){
		var self = this;
		var cId = self.params.get("id");

		console.log(cDataSource);

		var cDataContainer = {};
		cDataContainer.id = cDataSource.id;
		cDataContainer.title = cDataSource.title;
		cDataContainer.badge = cDataSource.badge;
		cDataContainer.availability = [];
		if(cDataSource.availability!=null && cDataSource.availability!=0){
			for (var i = 1; i <= cDataSource.availability; i++) {
				if((i>0 && i<11) || i==15 || i == 20 || i == 30 || i==50 || i==100 || i==200){
					cDataContainer.availability.push(i);
				}
			};
		}
		else{
			cDataContainer.availability.push(0);
		}
		cDataContainer.pinned = app.system.checkProductOnPinnedProductsList(cId);
		cDataContainer.availability_max = cDataSource.availability;
		cDataContainer.seller_username = cDataSource.seller.username;
		cDataContainer.seller_avatar = cDataSource.avatar;

		cDataContainer.images = [];
		_(cDataSource.images).forEach(function(cElement){
			if(cElement.default){
				cDataContainer.images.push({url:cElement.url.long});
				cDataContainer.description_image = cElement.url.listview_s;
			}
		});
		_(cDataSource.images).forEach(function(cElement){
			if(!cElement.default){
				cDataContainer.images.push({url:cElement.url.long});
			}
		});
		if(cDataSource.sale_percentage!=null){
			cDataContainer.sale_percentage = '-'+cDataSource.sale_percentage+'%';
		}
		cDataContainer.discounted = cDataSource.discounted;
		cDataContainer.sold_in_unit = cDataSource.sold_in_unit;
		cDataContainer.price = app.system.formatAmount(cDataSource.price.cents, cDataSource.price.currency);
		if(cDataSource.discounted){
			if(cDataSource.undiscounted_price.cents!=null){
				cDataContainer.undiscounted_price = app.system.formatAmount(cDataSource.undiscounted_price.cents, cDataSource.undiscounted_price.currency);
			}
			else{
				cDataSource.discounted = false;
			}
		}
		if(cDataSource.sold_in_unit){
			if(cDataSource.base_price.cents!=null && cDataSource.units_per_item.formatted!=null){
				cDataContainer.base_price = app.system.formatAmount(cDataSource.base_price.cents, cDataSource.base_price.currency) + ' / ' + $.t('pdp.units.'+cDataSource.unit);
				cDataContainer.quantity_per_item = cDataSource.units_per_item.formatted + ' ' + $.t('pdp.units.'+cDataSource.units_per_item.unit);
			}
			else{
				cDataSource.sold_in_unit = false;
			}
		}

		//Product Description
		cDataContainer.pdpProductDescriptionOnClickFunction = function(){
			console.log('onclick fired');
			app.nav.loadPage(
				'#pdpProductDescription',
				{
					'id':cDataSource.id,
					'refPageId':self.id(),
					'description_title':cDataSource.title,
					'description_text':cDataSource.description,
					'description_size':cDataSource.size_description,
					'description_material':cDataSource.material_description,
					'description_manufacturing':cDataSource.manufacturing_description,
					'description_individualisation':cDataSource.individualisation_description,
					'description_image':cDataContainer.description_image,
					'seller_username':cDataSource.seller.username,
					'seller_avatar':cDataSource.avatar,
					'availability_max':cDataSource.availability
				}
			);
			$('.buttongroup .link').removeClass('active');
		}
		cDataContainer.pdpShippingPaymentOnClickFunction = function(){
			app.nav.loadPage(
				'#pdpShippingPayment',
				{
					'id':cDataSource.id,
					'refPageId':self.id(),
					'description_title':cDataSource.title,
					'description_image':cDataContainer.description_image,
					'seller_username':cDataSource.seller.username,
					'seller_avatar':cDataSource.avatar,
					'availability_max':cDataSource.availability
				}
			);
			$('.buttongroup .link').removeClass('active');
		}
		cDataContainer.pdpProductImprintTermsReturnsOnClickFunction = function(){
			app.nav.loadPage(
				'#pdpProductImprintTermsReturns',
				{
					'id':cDataSource.id,
					'refPageId':self.id(),
					'description_title':cDataSource.title,
					'description_image':cDataContainer.description_image,
					'seller_username':cDataSource.seller.username,
					'seller_avatar':cDataSource.avatar,
					'availability_max':cDataSource.availability
				}
			);
			$('.buttongroup .link').removeClass('active');
		}
		cDataContainer.pdpProductSellerOnClickFunction = function(){
			app.nav.loadPage(
				'#pdpProductSeller',
				{
					'id':cDataSource.id,
					'refPageId':self.id(),
					'shopId':cDataSource.shop.id,
					'description_title':cDataSource.title,
					'description_image':cDataContainer.description_image,
					'availability_max':cDataSource.availability
				}
			);
			$('.buttongroup .link').removeClass('active');
		}

		return cDataContainer;
	},
	toggleAilabilityList: function(cObj){
		var self = this;
		var cPage = self.page.get();
		var cList = $(cObj).parent().children('ul:first');
		if(cList.css('display') == 'none'){
			cList.css({'display':'block'});
			$(cObj).addClass('active');
			$(cObj).parent().addClass('active');
		}
		else{
			cList.css({'display':'none'});
			$(cObj).removeClass('active');
			$(cObj).parent().removeClass('active');
		}
	},
	closeAilabilityList: function(cObj){
		var self = this;
		var cPage = self.page.get();
		$(cObj).parent().css({'display':'none'});
		$(cObj).parent().parent().children('div:first').html($(cObj).html());
		cPage.find('.availability-list-current-value').parent().removeClass('active');
	},
	addToCart: function(){
		var self = this;
		var cPage = self.page.get();
		var cId = self.params.get("id");
		var quantity = cPage.find('.availability-list-current-value').html();
		var cAvailability = self.data.pdpData.availability_max;
		app.api.doAPIRequestAsync(
			':api',
			'cart_items',
			{},
			'get',
			function(result){
				_(result.data).forEach(function(cElement){
					if(cElement.product_id==cId){
						cAvailability = cAvailability-cElement.quantity;
					}
				});
				if(cAvailability>0){
					app.api.doAPIRequestAsync(
						':apiPost',
						'cart_items',
						{'cart_item':{'product_id':cId, 'quantity':quantity}},
						'post',
						function(result2){
							if(result2.result===true){
								analytics.trackEvent('Cart', 'added-to-cart', null, cId);
								var cLang = app.settings.get('LANGUAGE');
								if(device.platform.toLowerCase()=='android'){
									// adjust android add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('m3b3c1');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('nbhx7d');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('mlhmsu');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('prrwuy');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('si2sxy');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('1zduhl');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('wqzphj');
									}
								}
								else if(device.platform.toLowerCase()=='ios'){
									// adjust ios add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('bq1h8u');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('k8g1a5');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('spud5p');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('coo8mt');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('poong4');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('fegcf0');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('ql6psr');
									}
								}
								app.nav.alert.show($.t('pdp.messages.successAddedToCart'));
								app.api.doAPIRequestAsync(
									':api',
									'cart_items/count',
									{},
									'get',
									function(result3){
										if(result3.result===true){
											app.system.cartCountValue(result3.data);
										}
									},
									function(){
										app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
									}
								);
							}
							else{
								app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
							}
						},
						function(){
							app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
						}
					);
				}
				else{
					app.nav.alert.show($.t('pdp.messages.errorMaxAvailInCart'), 'error');
				}
			},
			function(){
				app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
			}
		);
	}
};