model = {
	// definitions
	_def: {
		itemsPerPage: 40,
		page: 1,
		slotTolerance: 50,
		slotDefaultHeight: 200,
		scrollBottomTolerance: 3000,
		filter: {
			maxPrice: null,
			searchQuery: null,
			color: [],
			inSale: null
		},
		title: ''
	},
	onLoad: function(sC,eC){
		var self = this;
		var cPage = self.page.get();

		var part1 = function(p1_sC,p1_eC){

			cId = self.params.get('id');
			//cId = '41964414';
			refPageId = self.params.get('refPageId');

			cPage.find('.more-country-link a').click(function(){
				cPage.find('.more-shipping-content').toggleClass('active');
			});

			app.api.doAPIRequestAsync(
				':api',
				'shops/' + self.params.get('shopId'),
				{products:{page:1, per_page:1}},
				'get',
				function(result){
					if(result.result===true){
						self.data.pdpData = result.data;
						var tmpRating = self.data.pdpData.seller.rating;
						self.data.pdpData.seller.rating = [];
						for(var i = 0; i < 5; i++) {
							if(i<tmpRating){
								self.data.pdpData.seller.rating[i] = true;
							}
							else{
								self.data.pdpData.seller.rating[i] = false;
							}
						};
						self.data.pdpData.seller.featured_message = formatString(self.data.pdpData.featured_message);
						// datum für "mitglied seid" wird neu zusammengebaut
						self.data.pdpData.seller.created_at = self.data.pdpData.seller.created_at.substr(8, 2) + '.' + self.data.pdpData.seller.created_at.substr(5, 2) + '.' + self.data.pdpData.seller.created_at.substr(0, 4);

						if(!self.params.get('description_title') || !self.params.get('description_image') || !self.params.get('availability_max')){
							self.data.pdpData.displayArticle = false;
						}
						else{
							self.data.pdpData.displayArticle = true;

							self.data.pdpData.description_title = self.params.get('description_title');
							self.data.pdpData.description_image = self.params.get('description_image');
							self.data.pdpData.availability_max = self.params.get('availability_max');

							self.data.pdpData.pdpShippingPaymentOnClickFunction = function(){
								app.nav.loadPage(
									'#pdpShippingPayment',
									{
										'id':cId,
										'refPageId':refPageId,
										'description_title':self.data.pdpData.description_title,
										'description_image':self.data.pdpData.description_image,
										'seller_username':self.data.pdpData.seller.username,
										'seller_avatar':self.data.pdpData.seller.default_image.avatar,
										'availability_max':self.data.pdpData.availability_max
									}
								);
							}
							self.data.pdpData.pdpProductImprintTermsReturnsOnClickFunction = function(){
								app.nav.loadPage(
									'#pdpProductImprintTermsReturns',
									{
										'id':cId,
										'refPageId':refPageId,
										'description_title':self.data.pdpData.description_title,
										'description_image':self.data.pdpData.description_image,
										'seller_username':self.data.pdpData.seller.username,
										'seller_avatar':self.data.pdpData.seller.default_image.avatar,
										'availability_max':self.data.pdpData.availability_max
									}
								);
							}
						}

						p1_sC();
					}
					else{
						app.nav.alert.show($.t('pdp.messages.errorUnknownError'),'error');
						self.page.remove();
						p1_eC();
					}
				},
				p1_eC
			);
		}

		var part2 = function(){

			// prepare scroll-bottom-distance
			self.func.set("scroll-bottom-tolerance",self._def.scrollBottomTolerance);

			// set observableData
			self.data.inspireSourcesColumnLeft = ko.observableArray();
			self.data.inspireSourcesColumnRight = ko.observableArray();

			// this is the refresher var for all DOM events
			self.computedRefresher = ko.observable(0);

			// the temporary stored products from the api
			self.tempProductList = [];

			// this is a var to stop bottomScroll loading (used, if no more products available)
			self.productLoadStatus = true;

			// this is a var, to prevent double-bottom(in/out) scroll and load data multiple times
			self.productLoadHold = false;

			// this is the computed function for all new elements
			self.computedProductList = ko.computed(function(){
				var _x = self.computedRefresher();

				var _tmp = self.getSmallerColumn();

				var cPos = _tmp.start;
				var startCount = 0;
				var startAmount = _tmp.amount;
				var startUse = _tmp.use;
				_(self.tempProductList).forEach(function(preProduct){
					if (startCount < startAmount){
						if (startUse == 'left'){
							self.data.inspireSourcesColumnLeft.push(preProduct);
						}else{
							self.data.inspireSourcesColumnRight.push(preProduct);
						}
						startCount++;
						return;
					}

					if (cPos%2==0){
						self.data.inspireSourcesColumnLeft.push(preProduct);
					}else{
						self.data.inspireSourcesColumnRight.push(preProduct);
					}
					cPos++;
				});
				// clean product list
				self.tempProductList = [];

				// hide-show noResults container
				if (self.productLoadStatus == false){
					if (self.data.inspireSourcesColumnLeft().length == 0 && self.data.inspireSourcesColumnRight().length == 0){
						self.page.getNoResults().removeClass("hidden");
					}

					// hide loadingContainer
					self.page.getLoading().addClass("hidden");
				}else{
					// hide no results container
					if(!self.page.getNoResults().hasClass("hidden")){
						self.page.getNoResults().addClass("hidden");
					}

					// show loading container
					/*if(self.page.getLoading().hasClass("center")){
						self.page.getLoading().removeClass("center");
					}*/
					self.page.getLoading().removeClass("hidden");
				}
			});

			// slot position-data || {domPos: 1234, status: false, id: null}
			self.slotData = {};

			var _loadAPI = function(){
				app.nav.showContainer("loading",true);

				// get products from API
				self.getDataFromAPI(
					function(iData){
						self._def.title = iData.name;

						// refresh list now
						self.computedRefresher(self.computedRefresher()+1);

						// workaround for iOS devices
						self.loadAllDataSlots();
						sC();
					},
					function(result){
						if(result.result===false || result.statusText=="timeout"){
							app.nav.alert.show($.t('inspire.messages.errorUnknownError'),'error');
						}
						else{
							app.nav.alert.show($.t('inspire.messages.noProductsFound'),'info');
						}
						self.page.remove();
						eC();
					}
				);
			};

			_loadAPI();
		}

		part1(part2,eC);
	},
	afterShow: function(sC,eC){
		var self = this;
		self.loadAllDataSlots();
		sC();
		return;
		self.registerScrollPositions();
		// fire onScroll for first elements
		self.onScroll(null,null,self.page.getScrollData());
		sC();
	},
	toggleHeadContainer: function(showHeader){
		var self = this;

		if (showHeader){
			models("#header").changeHeader('text', $.t('pdp.shop'));
		}
		else{
			models("#header").changeHeader('logo');
		}		
	},
	addToCart: function(){
		var self = this;
		var cPage = self.page.get();
		var cId = self.params.get("id");
		var quantity = 1;
		var cAvailability = self.data.pdpData.availability_max;
		app.api.doAPIRequestAsync(
			':api',
			'cart_items',
			{},
			'get',
			function(result){
				_(result.data).forEach(function(cElement){
					if(cElement.product_id==cId){
						cAvailability = cAvailability-cElement.quantity;
					}
				});
				if(cAvailability>0){
					app.api.doAPIRequestAsync(
						':apiPost',
						'cart_items',
						{'cart_item':{'product_id':cId, 'quantity':quantity}},
						'post',
						function(result2){
							if(result2.result===true){
								analytics.trackEvent('Cart', 'added-to-cart', null, cId);
								var cLang = app.settings.get('LANGUAGE');
								if(device.platform.toLowerCase()=='android'){
									// adjust android add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('m3b3c1');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('nbhx7d');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('mlhmsu');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('prrwuy');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('si2sxy');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('1zduhl');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('wqzphj');
									}
								}
								else if(device.platform.toLowerCase()=='ios'){
									// adjust ios add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('bq1h8u');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('k8g1a5');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('spud5p');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('coo8mt');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('poong4');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('fegcf0');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('ql6psr');
									}
								}
								app.nav.alert.show($.t('pdp.messages.successAddedToCart'));
								app.api.doAPIRequestAsync(
									':api',
									'cart_items/count',
									{},
									'get',
									function(result3){
										if(result3.result===true){
											app.system.cartCountValue(result3.data);
										}
									},
									function(){
										app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
									}
								);
							}
							else{
								app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
							}
						},
						function(){
							app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
						}
					);
				}
				else{
					app.nav.alert.show($.t('pdp.messages.errorMaxAvailInCart'), 'error');
				}
			},
			function(){
				app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
			}
		);
	},
	registerScrollPositions: function(){
		var self = this;
		var cPage = self.page.get();

		_.forEach(self.slotData,function(cSlot){
			if (_.isNull(cSlot.domPos)){
				var dSlot = cPage.find("[data-slot='"+cSlot.id+"']");
				if (dSlot.length > 0){
					self.slotData[cSlot.id].domPos = dSlot.offset().top;
				}
			}
		});
	},
	loadDataSlot: function(slotId){
		var self = this;
		var cPage = self.page.get();
		var dImg = cPage.find("[data-img='"+slotId+"']");
		var slotData = self.slotData[slotId];
		if (dImg.length > 0 && slotData.img != ""){
			dImg.attr("src",slotData.img);
			delete self.slotData[slotId];
		}
	},
	loadAllDataSlots: function(){
		var self = this;
		_.forEach(self.slotData,function(cSlot,slotId){
			self.loadDataSlot(slotId);
		});
	},
	onFilterRefresh: function(newFilterValues){
		var self = window.model;
		self._def.filter.maxPrice = newFilterValues.maxPrice;
		self._def.filter.searchQuery = newFilterValues.searchQuery;
		self._def.filter.color = newFilterValues.color;
		self._def.filter.inSale = newFilterValues.inSale;

		self.productLoadStatus = true;

		// append center class for big scrolling
		//self.page.getLoading().addClass("center");

		// clear old data
		self.data.inspireSourcesColumnLeft.removeAll();
		self.data.inspireSourcesColumnRight.removeAll();

		// reset onload transitions
		self.func.get("img-onload-transition").cpos = 0;

		// reset page
		self._def.page = 1;

		// call 'scrollBottom' to reload
		self.onScrollBottom();
	},
	onScroll: function(sC,eC,scrollData){
		((_.isNull(sC))?sC=function(){}:null);
		((_.isNull(eC))?eC=function(){}:null);
		var self = this;

		sC();
		return;

		var cViewport = scrollData.viewport;
		var cPage = self.page.get();

		_.forEach(self.slotData,function(cSlot,slotId){
			if ((cSlot.domPos-scrollData.top-self._def.slotTolerance) <= cViewport){
				self.loadDataSlot(slotId);
			}
		});
		sC();
	},
	onScrollBottom: function(sC,eC,sData){
		((!sC)?sC=function(){}:null);
		((!eC)?eC=function(){}:null);
		((!sData)?sData={}:null);
		var self = this;

		// check if more products are empty
		if (!self.productLoadStatus){
			sC();
			return;
		}

		// check pHold
		if (self.productLoadHold){
			sC();
			return;
		}
		// set pHold
		self.productLoadHold = true;

		// show loadingContainer
		self.page.getLoading().removeClass("hidden");

		var _loadAPI = function(){
			// get products from API
			self.getDataFromAPI(
				function(iData){
					// refresh list now
					self.computedRefresher(self.computedRefresher()+1);

					// workaround for iOS devices
					self.loadAllDataSlots();
					self.productLoadHold = false;
					self.func.set("scroll-bottom-state",true);
					sC();
				},
				function(result){
					if(result.result===false || result.statusText=="timeout"){
						app.nav.alert.show($.t('inspire.messages.errorUnknownError'),'error');
					}
					// workaround for iOS devices
					self.loadAllDataSlots();
					self.productLoadHold = false;
					self.func.set("scroll-bottom-state",true);
					sC();
				}
			);
		};

		window.setTimeout(function(){
			_loadAPI();
		},250);
	},
	toggleHeadContainer: function(showHeader){
		var self = this;

		if (showHeader){
			models("#header").changeHeader('text', self._def.title);
		}else{
			models("#header").changeHeader('logo');
		}		
	},
	refreshFilter: function(){
		var self = this;
		var cValues = {};
		var filterModel = models("#filter");
		if(self._def.filter.maxPrice != null){
			cValues.maxPrice = self._def.filter.maxPrice;
			if(app.settings.get('CURRENCY').toLowerCase() == 'gbp'){
				cValues.maxPrice = Math.ceil(cValues.maxPrice * app.settings.get('CURRENCY_GBP'));
			}
			else if(app.settings.get('CURRENCY').toLowerCase() == 'pln'){
				cValues.maxPrice = Math.ceil(cValues.maxPrice * app.settings.get('CURRENCY_PLN'));
			}
		}
		else{
			cValues.maxPrice = filterModel._def.filter.maxPriceDefault;
			if(app.settings.get('CURRENCY').toLowerCase() == 'gbp'){
				cValues.maxPrice = Math.ceil(cValues.maxPrice * app.settings.get('CURRENCY_GBP'));
			}
			else if(app.settings.get('CURRENCY').toLowerCase() == 'pln'){
				cValues.maxPrice = Math.ceil(cValues.maxPrice * app.settings.get('CURRENCY_PLN'));
			}
		}
		if(self._def.filter.color.length > 0){
			cValues.color = self._def.filter.color;
		}
		else{
			cValues.color = filterModel._def.filter.colorDefault;
		}

		if(self._def.filter.inSale !== null){
			cValues.inSale = self._def.filter.inSale;
		}
		else{
			cValues.inSale = filterModel._def.filter.inSaleDefault;
		}
		cValues.searchQuery = self.params.get('searchQuery');

		models("#filter").registerCallback(self.onFilterRefresh);
		models("#filter").setValues(cValues);
	},
	toggleFilterContainer: function(showFilter){
		var self = this;

		if (showFilter){
			app.nav.showLevel(3);
		}else{
			app.nav.hideLevel(3);
		}
	},
	getDataFromAPI: function(sC,eC){
		((!eC)?eC=function(){}:null);
		var self = this;

		var rParams = {
			products:{
				page: self._def.page,
				per_page: self._def.itemsPerPage
			}
		};

		app.api.doAPIRequestAsync(
			':api',
			'shops/' + self.params.get('shopId'),
			rParams,
			'get',
			function(result){
				if(result.result===true){
					var iData = result.data;
					// check for valid result
					if (iData){
						self._def.page++;

						if (iData.products && iData.products.length > 0){
							_(iData.products).forEach(function(cProduct){
								var pProduct = self.prepareProduct(cProduct);
								self.tempProductList.push(pProduct);
								self.slotData[cProduct.id] = {domPos: null,id:pProduct.id,img: pProduct.image};
							});

							// check for max length reached
							if (iData.products.length < self._def.itemsPerPage){
								self.productLoadStatus = false;
							}
						}else{
							// prevent loading additional data
							self.productLoadStatus = false;
						}
						sC(iData);
					}else{
						eC(result);
					}
				}
				else{
					eC(result);
				}
			},
			eC
		);
	},
	getSmallerColumn: function(){
		var self = this;
		var cPage = self.page.get();
		var leftColumnSize = cPage.find('.shop-products:first').find(".col-50:first").height();
		var rightColumnSize = cPage.find('.shop-products:first').find(".col-50:last").height();

		var useAmount = 0;
		var use = "left";
		var startPos = 0;

		if (leftColumnSize == rightColumnSize){
			// do nothing
		}else if(leftColumnSize > rightColumnSize){
			useAmount = Math.ceil((leftColumnSize-rightColumnSize)/self._def.slotDefaultHeight);
			use = "right";
			startPos = 0;
		}else{
			useAmount = Math.ceil((rightColumnSize-leftColumnSize)/self._def.slotDefaultHeight);
			startPos = 1;
		}
		return {'use': use, amount: useAmount, start: startPos};
	},
	prepareProduct: function(cProduct){
		var self = this;

		var cDataContainer = {
			id: cProduct.id,
			title: cProduct.title,
			badge: cProduct.badge,
			sale_percentage: ((cProduct.sale_percentage!=null)?cProduct.sale_percentage:"")
		};

		_(cProduct.images).forEach(function(cImage){
			if(cImage.default){
				cDataContainer.image = 'http:'+cImage.url.full;
			}
		});

		if(app.system.checkProductOnPinnedProductsList(cProduct.id)){
			cDataContainer.pinned = true;
		}
		else{
			cDataContainer.pinned = false;
		}
		if(cProduct.sold_in_unit==false && cProduct.discounted==false){
			cDataContainer.price = app.system.formatAmount(cProduct.price.cents, cProduct.price.currency);
			cDataContainer.price_small = ' ';
			cDataContainer.price_sale = false;
			cDataContainer.price_small_sale = false;
		}
		else if(cProduct.sold_in_unit==false && cProduct.discounted){
			cDataContainer.price = app.system.formatAmount(cProduct.price.cents, cProduct.price.currency);
			cDataContainer.price_small = app.system.formatAmount(cProduct.undiscounted_price.cents, cProduct.price.currency);
			cDataContainer.price_sale = true;
			cDataContainer.price_small_sale = true;
		}
		else if(cProduct.sold_in_unit && cProduct.discounted==false){
			cDataContainer.price = app.system.formatAmount(cProduct.price.cents, cProduct.price.currency);
			cDataContainer.price_small = app.system.formatAmount(cProduct.base_price.cents, cProduct.price.currency) + '/' + $.t('pdp.units.'+cProduct.unit);
			cDataContainer.price_sale = false;
			cDataContainer.price_small_sale = false;
		}
		else if(cProduct.sold_in_unit && cProduct.discounted){
			cDataContainer.price = app.system.formatAmount(cProduct.price.cents, cProduct.price.currency);
			cDataContainer.price_small = app.system.formatAmount(cProduct.base_price.cents, cProduct.price.currency) + '/' + $.t('pdp.units.'+cProduct.unit);
			cDataContainer.price_sale = true;
			cDataContainer.price_small_sale = false;
		}
		return cDataContainer;
	},
	toggleSellerProfile: function(){
		var self = this;
		var cPage = self.page.get();
		cPage.find('.tables-content').find('.table-col').each(function(sellerProfileKey, sellerProfileObj){
			if(sellerProfileKey>0 && sellerProfileKey<4){
				$(sellerProfileObj).toggleClass('hidden');
			}
		});
		cPage.find('.product-info:first').toggleClass('hidden');
		cPage.find('.moreless').toggleClass('hidden');
	}
};