model = {
	onLoad: function(sC,eC){
		var self = this;
		var cPage = self.page.get();

		cId = self.params.get('id');
		//cId = '57518547';
		refPageId = self.params.get('refPageId');

		cPage.find('.more-country-link').click(function(){
			cPage.find('.more-shipping-content').toggleClass('active');
			if($(this).attr('data-status')=='closed'){
				$(this).find('[data-type="text"]:first').html($.t('pdp.fewerCountries'));
				$(this).attr('data-status', 'opened');
			}
			else{
				$(this).find('[data-type="text"]:first').html($.t('pdp.moreCountries'));
				$(this).attr('data-status', 'closed');
			}
		});

		app.api.doAPIRequestAsync(
			':api',
			'product_payment_shipping_details/' + cId,
			{},
			'get',
			function(result){
				if(result.result===true){
					self.data.pdpData = result.data;
					self.data.pdpData.description_title = self.params.get('description_title');
					self.data.pdpData.description_image = self.params.get('description_image');
					self.data.pdpData.seller_username = self.params.get('seller_username');
					self.data.pdpData.seller_avatar = self.params.get('seller_avatar');
					self.data.pdpData.availability_max = self.params.get('availability_max');
					if(self.data.pdpData.free_shipping_amount!=null){
						self.data.pdpData.free_shipping_amount = app.system.formatAmount(self.data.pdpData.free_shipping_amount.cents, self.data.pdpData.free_shipping_amount.currency);
					}
					var tmpShippingFees = self.data.pdpData.shipping_fees;
					self.data.pdpData.shipping_fees = [];
					_.forEach(tmpShippingFees, function(oValue,oKey){
						if(oValue.single!=null && oValue.single!=0){
							oValue.single = app.system.formatAmount(oValue.single, oValue.currency);
						}
						if(oValue.combi!=null && oValue.combi!=0){
							oValue.combi = app.system.formatAmount(oValue.combi, oValue.currency);
						}
						if(oValue.max!=null && oValue.max!=0){
							oValue.max = app.system.formatAmount(oValue.max, oValue.currency);
						}
						self.data.pdpData.shipping_fees.push({country:$.t('countries:'+oKey), single:oValue.single, combi:oValue.combi, max:oValue.max});
					});

					var tmpPaymentMethods = self.data.pdpData.payment_methods;
					self.data.pdpData.payment_methods = [];
					_(tmpPaymentMethods).forEach(function(cElement){
	            		var title = '';
	            		var images = '';
						if(cElement == 'wirecard.credit_card'){
							title = $.t('pdp.paymentmethods.wirecardCreditCard');
							images = '<span class="pay-mastercardMSC"> </span><span class="pay-visa"></span> <span class="pay-visaVbV"></span>';
						}
						else if(cElement == 'PayPal'){
							title = $.t('pdp.paymentmethods.PayPal');
							images = '<span class="pay-paymentde"></span>';
						}
						else if(cElement == 'wirecard.sofort'){
							title = $.t('pdp.paymentmethods.wirecardSofort');
							images = '<span class="pay-sofort"></span>';
						}
						else if(cElement == 'wirecard.ideal'){
							title = $.t('pdp.paymentmethods.wirecardIdeal');
							images = '<span class="pay-ideal"></span>';
						}
						else if(cElement == 'wirecard.eps'){
							title = $.t('pdp.paymentmethods.wirecardEps');
							images = '<span class="pay-eps"></span>';
						}
						else if(cElement == 'wirecard.maestro'){
							title = $.t('pdp.paymentmethods.wirecardMaestro');
							images = '<span class="pay-maestro"></span>';
						}
						else if(cElement == 'BankTransfer'){
							title = $.t('pdp.paymentmethods.BankTransfer');
						}
						else if(cElement == 'Cash'){
							title = $.t('pdp.paymentmethods.Cash');
						}
						else if(cElement == 'DaWandaVoucher'){
							title = $.t('pdp.paymentmethods.DaWandaVoucher');
						}
						self.data.pdpData.payment_methods.push({'title':title, 'images':images});
					});

					self.data.pdpData.pdpShippingPaymentOnClickFunction = function(){
						app.nav.loadPage(
							'#pdpShippingPayment',
							{
								'id':cId,
								'refPageId':refPageId,
								'description_title':self.data.pdpData.description_title,
								'description_image':self.data.pdpData.description_image,
								'seller_username':self.data.pdpData.seller_username,
								'seller_avatar':self.data.pdpData.seller_avatar,
								'availability_max':self.data.pdpData.availability_max
							}
						);
					}
					self.data.pdpData.pdpProductImprintTermsReturnsOnClickFunction = function(){
						app.nav.loadPage(
							'#pdpProductImprintTermsReturns',
							{
								'id':cId,
								'refPageId':refPageId,
								'description_title':self.data.pdpData.description_title,
								'description_image':self.data.pdpData.description_image,
								'seller_username':self.data.pdpData.seller_username,
								'seller_avatar':self.data.pdpData.seller_avatar,
								'availability_max':self.data.pdpData.availability_max
							}
						);
					}
					
					app.api.doAPIRequestAsync(
						':api',
						'product_seller_details/' + cId,
						{},
						'get',
						function(result_2){
							if(result_2.result===true){
								self.data.pdpData.shipping_info = formatString(result_2.data.seller.shop.shipping_info);
								self.data.pdpData.seller_country = result_2.data.seller.country;
								if(self.data.pdpData.mailable_in_option != null){
									self.data.pdpData.mailableText = $.t('pdp.mailableInOptions.option_'+self.data.pdpData.mailable_in_option)+'. '+$.t('pdp.mailableToShopCountry_1')+$.t('countries:'+result_2.data.seller.country)+$.t('pdp.mailableToShopCountry_2');
								}
								else{
									self.data.pdpData.mailableText = $.t('pdp.mailableInOptions.option_none');
								}
								sC();
							}
							else{
								app.nav.alert.show($.t('pdp.messages.errorUnknownError'),'error');
								self.page.remove();
								eC();
							}
						},
						eC
					);
				}
				else{
					app.nav.alert.show($.t('pdp.messages.errorUnknownError'),'error');
					self.page.remove();
					eC();
				}
			},
			eC
		);
	},
	onFocus: function(sC,eC){
		var self = this;
		self.toggleHeadContainer(true);
		sC();
	},
	onBlur: function(sC,eC){
		var self = this;
		self.toggleHeadContainer(false);
		sC();
	},
	toggleHeadContainer: function(showHeader){
		var self = this;

		if (showHeader){
			models("#header").changeHeader('text', $.t('pdp.paymentAndShipping'));
		}
		else{
			models("#header").changeHeader('logo');
		}		
	},
	addToCart: function(){
		var self = this;
		var cPage = self.page.get();
		var cId = self.params.get("id");
		var quantity = 1;
		var cAvailability = self.data.pdpData.availability_max;
		app.api.doAPIRequestAsync(
			':api',
			'cart_items',
			{},
			'get',
			function(result){
				_(result.data).forEach(function(cElement){
					if(cElement.product_id==cId){
						cAvailability = cAvailability-cElement.quantity;
					}
				});
				if(cAvailability>0){
					app.api.doAPIRequestAsync(
						':apiPost',
						'cart_items',
						{'cart_item':{'product_id':cId, 'quantity':quantity}},
						'post',
						function(result2){
							if(result2.result===true){
								analytics.trackEvent('Cart', 'added-to-cart', null, cId);
								var cLang = app.settings.get('LANGUAGE');
								if(device.platform.toLowerCase()=='android'){
									// adjust android add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('m3b3c1');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('nbhx7d');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('mlhmsu');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('prrwuy');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('si2sxy');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('1zduhl');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('wqzphj');
									}
								}
								else if(device.platform.toLowerCase()=='ios'){
									// adjust ios add to cart event
									if(cLang=='de'){
										Adjust.trackEvent('bq1h8u');
									}
									else if(cLang=='en'){
										Adjust.trackEvent('k8g1a5');
									}
									else if(cLang=='es'){
										Adjust.trackEvent('spud5p');
									}
									else if(cLang=='fr'){
										Adjust.trackEvent('coo8mt');
									}
									else if(cLang=='it'){
										Adjust.trackEvent('poong4');
									}
									else if(cLang=='nl'){
										Adjust.trackEvent('fegcf0');
									}
									else if(cLang=='pl'){
										Adjust.trackEvent('ql6psr');
									}
								}
								app.nav.alert.show($.t('pdp.messages.successAddedToCart'));
								app.api.doAPIRequestAsync(
									':api',
									'cart_items/count',
									{},
									'get',
									function(result3){
										if(result3.result===true){
											app.system.cartCountValue(result3.data);
										}
									},
									function(){
										app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
									}
								);
							}
							else{
								app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
							}
						},
						function(){
							app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
						}
					);
				}
				else{
					app.nav.alert.show($.t('pdp.messages.errorMaxAvailInCart'), 'error');
				}
			},
			function(){
				app.nav.alert.show($.t('pdp.messages.errorUnknownError'), 'error');
			}
		);
	}
};