model = {
	onLoad: function(sC, eC){
		var self = this;
		var cPage = self.page.get();

		self.observedData = ko.observableArray();
				
		// this will bind the data to the template
		self.data.orderedInspireSources = ko.computed(function(){
			var rData = [];
			var cPos = -1;
			_(self.observedData()).forEach(function(cElement,cIndex){
				if (cIndex%2==0){
					cPos++;
					rData[cPos] = [];
				}
				rData[cPos].push(cElement);
			});
			return rData;
		}).extend({ throttle: 500 });	// refresh data only every 500ms after a change

		app.api.doAPIRequestAsync(
			':api',
			'categories',
			{},
			'get',
			function(result){
				if(result.result===true){
					_(result.data).forEach(function(cElement){
						cElement.e1_name = cElement.name;
						if(cElement.name.length>12){
							//letztes leerzeichen in der ersten zeile wird gesucht
							var llz_z1 = cElement.name.substr(0,12).lastIndexOf(' ');
							if(llz_z1!=(-1)){
								cElement.e1_name = cElement.name.substr(0,llz_z1) + '<br />' + cElement.name.substr(llz_z1+1);
								cElement.needTwoCols = true;
							}
							else{
								//erstes leerzeichen in der zweiten zeile wird gesucht
								var llz_z1 = cElement.name.substr(12,13).indexOf(' ');
								if(llz_z1!=(-1)){
									cElement.needTwoCols = true;
								}
								else{
									cElement.needTwoCols = false;
								}
							}
						}
						else{
							cElement.needTwoCols = false;
						}
						cElement.e1PageId = self.id();
						self.observedData.push(cElement);
					});

					sC();
				}
				else{
					if(result.result===false || result.statusText=="timeout"){
						app.nav.alert.show($.t('searchBrowse.messages.errorUnknownError'),'error');
					}
					else{
						app.nav.alert.show($.t('searchBrowse.messages.noProductsFound'),'info');
					}
					self.page.remove();
					eC();
				}
			},
			eC
		);
	},
	onFocus: function(sC, eC){
		var self = this;
		models("#footer").data.activeTab("search");
		models("#header").changeHeader('logo_show');
		sC();
	},
	onBlur: function(sC,eC){
		//models("#footer").data.activeTab("");
		sC();
	},
	afterShow: function(sC,eC){
		var self = this;
		var remainingPages = {
			'#startup':true,
			'#header':true,
			'#footer':true,
			'#filter':true,
			'#share':true
		};
		remainingPages[self.id()]=true;
		app.nav.showContainer('loading', true);
		app.nav.history.remove(
			remainingPages,
			function(succ){
				app.nav.hideContainer('loading');
				sC();
			}
		);
	},
	getE1Data: function(requestId){
		var self = this;
		var searchedItem = null;
		_(self.observedData()).forEach(function(cElement){
			if(cElement.id == requestId){
				searchedItem = cElement;
			}
		});
		return searchedItem;
	},
	search: function(){
		var searchInput = $('[data-ident="searchfield"]:first');
		app.nav.loadPage('#searchResult', {force:true, 'searchQuery':searchInput.val()}, function(){
			searchInput.blur();
		});
	},
	searchGetFocus: function(cObj){
		$(cObj).parent().addClass('active');
		app.nav.hideLevel(2);
	},
	searchLooseFocus: function(cObj){
		setTimeout(function(){
			$(cObj).parent().removeClass('active');
		}, 50);
		app.nav.showLevel(2);
	}
}