(function(app,windowModel){
	app.nav = {
		// need this for eListener
		_className: 'nav',
		
		// pre-defined templates
		_objTpl:{
			'pageData': '<div class="page right transition"></div>',
			'pageLvlData': '<div class="pageLevelContainer"></div>',
			'pageLvl': '.pageLevelContainer',
			'page': '.page',
			'main': '#main_container',
			'content': '.contentContainer'
		},

		// cache to store already assigned references (#app:/)
		_referenceCache: {

		},
		_registers: {

		},
		_h: {
			'pages':		[], // {id: '#init', model: {}, lvl: 0}
			'sequence': 	[],
			'memory':		[],
			'pointer': 		0
		},
		'history': {
			clear: function(){
				var self = app.nav;
				self._h.memory = [];
				console.warn("nav.history cleared");
				self.model._callRegisterFunc("refreshHistory");
				return true;
			},
			remove: function(ignorePages,sC){
				((!ignorePages)?ignorePages={}:null);
				((!sC)?sC=function(){}:null);
				var self = app.nav;
				//console.warn("nav.history removed");

				var _memClear = function(cPos){
					var remHandled = false;
					_(self._h.memory).forEach(function(cPagePos,mPos){
						if (remHandled == false && cPos == cPagePos){
							self._h.memory.splice(mPos,1);
							remHandled = true;
						}
					});
					if (remHandled){
						_memClear(cPos);
					}else{
						return true;
					}
				};

				var _delFunc = function(cPos){
					//console.warn("DEL: "+cPos);
					if (cPos >= self._h.pages.length){
						//console.warn("DELBREAK: "+cPos);
						self.model._callRegisterFunc("refreshHistory");
						sC();
						return;
					}

					var cPageObj = self._h.pages[cPos];

					if (cPageObj.id == "NULL"){
						_delFunc(cPos+1);
						return;
					}

					if ((!_.isUndefined(ignorePages[cPageObj.id])) && ignorePages[cPageObj.id] == true){
						_delFunc(cPos+1);
						return;
					}

					self.page.remove(cPageObj.id,function(){
						_memClear(cPos);
						//console.warn("DELDONE: "+cPos+" - "+cPageObj.id);
						_delFunc(cPos+1);
					});
				};

				// start del here
				_delFunc(0);
			}
		},
		'register': {
			pageCallback: function(targetFunc,callbackFunc){
				var self = app.nav;
				if (_.isUndefined(self._registers[targetFunc])){
					self._registers[targetFunc] = [];
				}
				self._registers[targetFunc].push(callbackFunc);
				return self._registers[targetFunc].length;
			},
			removeCallback: function(targetFunc,pos){
				var self = app.nav;
				if ((!_.isUndefined(self._registers[targetFunc])) && (!_.isUndefined(self._registers[targetFunc][pos]))){
					self._registers[targetFunc][pos] = function(e){return null;};
				}
			}
		},
		'alert': {
			show: function(alertMessage,alertType,alertOptions){
				((!alertOptions)?alertOptions={}:null);
				((!alertType)?alertType="success":null);
				var self = app.nav;

				if (_.isUndefined(alertOptions['displayTime'])){
					alertOptions['displayTime'] = 3;
				}

				// activate current alert container
				var fMContainer = $("#alert_container .alert-message:first");
				fMContainer.children("p:first").html(alertMessage);
				fMContainer.attr("class","alert-message "+alertType);
				$("#alert_container").addClass("slide-top");

				// prevent double timeouts - clear timeout, first
				if (!_.isUndefined(self._registers['alertTimeout'])){
					window.clearTimeout(self._registers['alertTimeout']);
				}

				// timeout callback function, remove alert-message
				self._registers['flashTimeout'] = window.setTimeout(function(){
					$("#alert_container").removeClass('slide-top');
				},(alertOptions['displayTime']*1000));
			}
		},
		'model': {
			clear: function(){
				windowModel = {};
				model = {};
				console.log("nav.model cleared");
			},
			restore: function(){
				var self = app.nav;
				model = self.page.get.pointerModel();
				console.log("nav.model restored ("+model.id()+")");
			},
			get: function(mdlId){
				((!mdlId)?mdlId=null:null);
				var self = app.nav;
				var mdlRet = {};

				if (_.isNull(mdlId)){
					mdlRet = self.page.get.pointerModel();
				}else{
					if (mdlId.charAt(0) != "#"){
						mdlId = "#"+mdlId;
					}

					_(self._h.pages).forEach(function(pageData){
						if (pageData.id == mdlId && (!_.isEmpty(pageData.model))){
							mdlRet = pageData.model;
						}
					});
				}
				return mdlRet;
			},
			assignFunctions: function(pageParams){
				var self = app.nav;
				var pModel = self.page.get.pointerModel();

				// central scroll callback function
				var _scrollCallback = function(){
					var wrapperContainer = pModel['page'].getWrapper();
					var scrollPosData = self.model._scrollCallbacks.scrollingPos(pModel,wrapperContainer);

					// check the bottom state and fires the callback
					self.model._scrollCallbacks._handle(pModel,"bottom",scrollPosData,"onScrollBottom");

					// check the top state and fires the callback
					self.model._scrollCallbacks._handle(pModel,"top",scrollPosData,"onScrollTop");

					// handle the scrolling callback
					self.model._eventFunc("onScroll",null,null,scrollPosData);
				};

				// append data, functions & options to current model
				pModel['_pageParams'] = pageParams;
				pModel['_pageParams']['_funcData'] = {};
				pModel['data'] = {};
				pModel['params'] = {
					'get': function(pKey){
						if (!_.isUndefined(pModel._pageParams[pKey])){
							return pModel._pageParams[pKey];
						}
						return null;
					},
					'getAll': function(){
						return pModel._pageParams;
					},
					'set': function(pKey,pValue){
						pModel._pageParams[pKey] = pValue;
					},
					'setAll': function(nData){
						pModel._pageParams = nData;
					}
				};
				pModel['page'] = {
					'get': function(){
						return $(".page[data-ident='"+pModel._pageParams.pageIdent+"']:first");
					},
					'getWrapper': function(){
						return $(".page[data-ident='"+pModel._pageParams.pageIdent+"'] .inner-wrapper:first");
					},
					'getContent': function(){
						return $(".page[data-ident='"+pModel._pageParams.pageIdent+"'] .scroll-content:first");
					},
					'getNode': function(){
						return $(".page[data-ident='"+pModel._pageParams.pageIdent+"']:first").get(0);
					},
					'getLoading': function(){
						return $(".page[data-ident='"+pModel._pageParams.pageIdent+"'] .loading-bar:first");
					},
					'getNoResults': function(){
						return $(".page[data-ident='"+pModel._pageParams.pageIdent+"'] .no-results:first");
					},
					'getLvl': function(){
						return $(".page[data-ident='"+pModel._pageParams.pageIdent+"']:first").closest(self._objTpl.pageLvl);
					},
					'remove': function(){
						self.page.remove(pModel._pageParams.pageIdent);
					},
					'getScrollData': function(){
						return self.model._scrollCallbacks.scrollingPos(pModel,pModel['page'].getWrapper());
					},
					'refreshLng': function(){
						if (GLOBALS.i18n.status){
							app.helper.nav.i18n.updateDomNode(pModel.page.get());
						}
					}
				};
				pModel['id'] = function(){
					return pModel['_pageParams'].pageIdent;
				};
				pModel['register'] = function(targetFunc,callbackFunc){
					if (_.isUndefined(self._registers[targetFunc])){
						self._registers[targetFunc] = [];
					}
					self._registers[targetFunc].push(callbackFunc);
				};
				pModel['func'] = {
					'get': function(funcName){
						if (!_.isUndefined(pModel['_pageParams']['_funcData'][funcName])){
							return pModel['_pageParams']['_funcData'][funcName];
						}
						return null;
					},
					'reset': function(funcName){
						if (!_.isUndefined(pModel['_pageParams']['_funcData'][funcName])){
							pModel['_pageParams']['_funcData'][funcName] = false;
						}
					},
					'set': function(funcName,funcValue){
						if (_.isUndefined(funcValue)){
							if (_.isUndefined(pModel['_pageParams']['_funcData'][funcName])){
								pModel['_pageParams']['_funcData'][funcName] = true;
							}
						}else{
							pModel['_pageParams']['_funcData'][funcName] = funcValue;
						}
					}
				};

				pModel['scroll'] = {
					'init': function(){
						var mScrollContent = pModel['page'].getContent();
						// check for content length
						if (mScrollContent.length == 0){
							return false;
						}

						// append a workaround for iOS devices
						if(app.settings.get("PLATFORM") == "ios"){
							pModel['scroll'].initIscroll();
						}

						// append a scrolling watcher
						mScrollContent.bind('scroll',_scrollCallback);
					},
					'initIscroll': function(){ return false;	// iScroll disabled
						pModel['scroll'].destroy();

						// check for content length
						if (pModel['page'].getContent().length > 0){
							var iScrollObj = new IScroll(pModel['page'].getContent().get(0),{
								probeType: 3,
								bounce: false,
								click: true,
								disableMouse: true,
								disablePointer: true,
								preventDefault: true,
								useTransition: true
							});
							iScrollObj.on('scroll',_scrollCallback);
							pModel.func.set("scroll-iscroll",iScrollObj);
						}
					},
					'refresh': function(){
						var iScrollObj = pModel.func.get("scroll-iscroll");
						if (!_.isNull(iScrollObj)){
							iScrollObj.refresh();
						}
					},
					'destroy': function(){
						var iScrollObj = pModel.func.get("scroll-iscroll");
						if (!_.isNull(iScrollObj)){
							iScrollObj.destroy();
							iScrollObj = null;
							pModel.func.set("scroll-iscroll",null);
						}
					}
				};

				// SETUP STATE FUNCTIONS - IMPORTANT!!!
				pModel.func.set("scroll-bottom-state",true);
				pModel.func.set("scroll-top-state",false);
				pModel.func.set("scroll-bottom-tolerance",0);
				pModel.func.set("scroll-top-tolerance",0);
				pModel.func.set("scroll-iscroll",null);
				pModel.func.set("scroll-lastpos",0);

				// first time call functions
				pModel.func.set("callback-onFocus-ftime",true);
				pModel.func.set("callback-onBlur-ftime",true);
				pModel.func.set("callback-afterShow-ftime",true);
				pModel.func.set("callback-afterBlur-ftime",true);

				// image load callback function for 'transitions'
				pModel.func.set("img-onload-transition",{
					cpos: 0,	// this is the current loaded position
					cbfunc:[],	// these are the callback functions
					tofunc: [],	// these are the 'secure' timeout functions
					cbhandle: function(toPos){
						var self = this;

						self.tofunc[toPos] = window.setTimeout(function(){
							console.warn("img-onload-transition callbackTimeout for: "+toPos+" - page:"+pModel.id());
							_runCBFunc(toPos);
						},3000);

						var _runCBFunc = function(pPos){
							if (pPos > self.cpos){
								self.cpos = pPos;
							}

							if (!_.isUndefined(self.cbfunc[pPos])){
								self.cbfunc[pPos]();
								if (!_.isUndefined(self.tofunc[pPos])){
									window.clearTimeout(self.tofunc[pPos]);
								}
								window.setTimeout(function(){
									_runCBFunc((pPos+1));
								},50);	// x - ms user exp. callback
							}
						};

						if (this.cpos >= toPos){
							_runCBFunc(toPos);
						}
					}
				});

				// append a scrolling watcher
				pModel['scroll'].init();

				return;
			},
			onLoad: function(successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				var pModel = self.page.get.pointerModel();
				// restore model
				self.model.restore();
				
				self.model._eventFunc(
					'onLoad',
					function(){
						ko.applyBindings(pModel.data,pModel.page.getNode());

						// refreshLng
						pModel.page.refreshLng();
						successCallback();
					},
					errorCallback
				);
				return;
			},
			onFocus: function(successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				self.model._eventFunc('onFocus',successCallback,errorCallback);
				return;
			},
			onBlur: function(successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				self.model._eventFunc('onBlur',successCallback,errorCallback);
				return;
			},
			onDelete: function(successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				self.model._eventFunc('onDelete',successCallback,errorCallback);
				return;
			},
			onScrollBottom: function(successCallback,errorCallback,eParams){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				self.model._eventFunc('onScrollBottom',successCallback,errorCallback,eParams);
				self.model._callRegisterFunc("onScrollBottom",eParams);
				return;
			},
			onScrollTop: function(successCallback,errorCallback,eParams){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				self.model._eventFunc('onScrollTop',successCallback,errorCallback,eParams);
				self.model._callRegisterFunc("onScrollTop",eParams);
				return;
			},
			onScroll: function(successCallback,errorCallback,eParams){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				self.model._eventFunc('onScroll',successCallback,errorCallback,eParams);
				self.model._callRegisterFunc("onScroll",eParams);
				return;
			},
			afterShow: function(successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				var pModel = self.page.get.pointerModel();
				
				self.model._eventFunc(
					'afterShow',
					function(){
						// refresh scrolling watcher
						pModel['scroll'].refresh();
						successCallback();
					},
					errorCallback
				);
				return;
			},
			afterBlur: function(successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				self.model._eventFunc('afterBlur',successCallback,errorCallback);
				return;
			},
			add: function(){
				var self = app.nav;
				var pPos = self.page.get.pointer();
				if ((!_.isUndefined(model)) && (!_.isNull(model)) && (!_.isEmpty(model))){
					self._h.pages[pPos].model = _.cloneDeep(model);
				}else{
					// create new empty model
					self._h.pages[pPos].model = {};
				}
			},
			_scrollCallbacks: {
				scrollingPos: function(pModel,cPage){
					// get device height
					var windowHeight = $("#content").height();

					// get scrollableHeight
					var disTop = parseInt(cPage.css("paddingTop").replace("px",""));
					var disBottom = parseInt(cPage.css("paddingBottom").replace("px",""));
					var scrollableHeight = windowHeight-disTop-disBottom;
					var maxHeight = cPage.height()-scrollableHeight;

					// current scroll position
					var posFromTop = -1*cPage.position().top; // 'position().top' is smaller than '0'
					var percFromTop = Math.round(posFromTop/maxHeight*100);

					var lastScrollPos = pModel.func.get("scroll-lastpos");
					var direction = ((lastScrollPos<posFromTop)?"down":"up");
					pModel.func.set("scroll-lastpos",posFromTop);

					return {top: posFromTop, max: maxHeight, perc: percFromTop, viewport: scrollableHeight, dir: direction};
				},
				bottom: function(scrollPosData,requestType,addTolerance){
					((!addTolerance)?addTolerance=200:null);
					((!requestType)?requestType="in":null);
					var tolIn = addTolerance;
					var tolOut = 10+addTolerance;

					// check for IN
					if (requestType == "in"){
						if (scrollPosData.max-scrollPosData.top <= tolIn){
							return true;
						}
					}
					// check for OUT
					else if (requestType == "out"){
						if (scrollPosData.max-scrollPosData.top >= tolOut){
							return true;
						}
					}
					return false;
				},
				top: function(scrollPosData,requestType,addTolerance){
					((!addTolerance)?addTolerance=50:null);
					((!requestType)?requestType="in":null);
					var tolIn = addTolerance;
					var tolOut = 10+addTolerance;

					// check for IN
					if (requestType == "in"){
						if (scrollPosData.top <= tolIn){
							return true;
						}
					}
					// check for OUT
					else if (requestType == "out"){
						if (scrollPosData.top >= tolOut){
							return true;
						}
					}
					return false;
				},
				_handle: function(pModel,stateType,scrollPosData,cbAction){
					var stateTypeName = "scroll-"+stateType+"-state";
					var scrollTolName = "scroll-"+stateType+"-tolerance";

					if (pModel.func.get(stateTypeName)){
						var scrolTolValue = pModel.func.get(scrollTolName);

						var inBottom = this[stateType](scrollPosData,"in",scrolTolValue);
						if (inBottom){
							console.log("pageScroll: "+stateType+"-in",scrollPosData);
							pModel.func.set(stateTypeName,false);
							// fire callback
							var self = app.nav;
							self.model._eventFunc(cbAction,null,null,scrollPosData);
						}
					}else{
						var scrolTolValue = pModel.func.get(scrollTolName);

						var outBottom = this[stateType](scrollPosData,"out",scrolTolValue);
						if (outBottom){
							console.log("pageScroll: "+stateType+"-out",scrollPosData);
							pModel.func.set(stateTypeName,true);
						}
					}
				}
			},
			_eventFunc: function(eventName,successCallback,errorCallback,eParams){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				((!eParams)?eParams={}:null);
				var self = app.nav;
				var pModel = self.page.get.pointerModel();
				eParams['firstCall'] = pModel.func.get("callback-"+eventName+"-ftime");

				var cT = window.setTimeout(function(){
					console.warn("No successCallback after 4 sec. ("+eventName+")");
				},4000);

				if (!_.isUndefined(pModel[eventName])){
					pModel[eventName](
						function(){
							window.clearTimeout(cT);
							self.model._callRegisterFunc(eventName,eParams);
							pModel.func.set("callback-"+eventName+"-ftime",false);
							successCallback();
						},
						errorCallback,
						eParams
					);
				}else{
					window.clearTimeout(cT);
					self.model._callRegisterFunc(eventName,eParams);
					pModel.func.set("callback-"+eventName+"-ftime",false);
					successCallback();
				}
			},
			_callRegisterFunc: function(eventName,eventParams){
				((!eventParams)?eventParams={}:null);
				var self = app.nav;

				var rResult = true;
				var cResult = null;
				if (!_.isUndefined(self._registers[eventName])){
					_(self._registers[eventName]).forEach(function(e){
						cResult = e(eventParams);
						if (cResult === false){
							rResult = false;
						}
					});
				}
				return rResult;
			}
		},
		page: {
			get: {
				'pointerModel': function(){
					var self = app.nav;
					var pPos = self.page.get.pointer();
					if (!_.isUndefined(self._h.pages[pPos])){
						return self._h.pages[pPos].model;
					}
					return {};
				},
				pointer: function(){
					var self = app.nav;
					return self._h.pointer;
				},
				currentPos: function(){
					var self = app.nav;
					return (self._h.memory.length-1);
				},
				previousPos: function(){
					var self = app.nav;
					return (self.page.get.currentPos()-1);
				},
				current: function(returnObj){
					((!returnObj)?returnObj=false:null);
					var self = app.nav;
					
					if (!_.isUndefined(self._h.pages[self.page.get.currentId()])){
						if (returnObj){
							return self._h.pages[self.page.get.currentId()];
						}
						return self._h.pages[self.page.get.currentId()].id;
					}
					return null;
				},
				currentId: function(){
					var self = app.nav;
					
					var cPos = self.page.get.currentPos();
					return self._h.memory[cPos];
				},
				id: function(pageName){
					var self = app.nav;
					var pId = -1;
					_(self._h.pages).forEach(function(cName,cPos){
						if (pageName == cName.id){
							pId = cPos;
						}
					});
					return pId;
				},
				nextId: function(){
					var self = app.nav;
					return self._h.pages.length;
				}
			},
			set: {
				pointer: function(nPointer){
					var self = app.nav;
					self._h.pointer = nPointer;
				}
			},
			is: {
				loadedPage: function(pageName){
					var self = app.nav;
					return ((self.page.get.id(pageName) >= 0)?true:false);
				},
				current: function(pageName){
					var self = app.nav;
					return ((self.page.get.current() == pageName)?true:false);
				}
			},
			add: function(pageName,pageLvl){
				((!pageLvl)?pageLvl=0:null);
				var self = app.nav;
				
				var nPageId = self.page.get.nextId();
				self._h.pages.push({id: pageName, model: {},lvl: pageLvl});
				// MDL-POINTER
				self.page.set.pointer(nPageId);
				
				// create new pageContainer
				var newPageObj = $(self._objTpl.pageData);
				newPageObj.attr("data-ident",pageName);
				newPageObj.attr("data-pos",nPageId);
				
				// appendPageContainer to mainContainer
				var mContainer = $(self._objTpl.main);

				// find pageLvl container
				var pageLvlContainer = mContainer.children(self._objTpl.pageLvl+"[data-lvl='"+pageLvl+"']:first");
				if (pageLvlContainer.length == 0){
					pageLvlContainer = $(self._objTpl.pageLvlData);
					pageLvlContainer.attr("data-lvl",pageLvl);
					mContainer.append(pageLvlContainer);
				}

				pageLvlContainer.append(newPageObj);
				return newPageObj;
			},
			remove: function(pageName,successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				console.warn("nav.remove ("+pageName+")");

				var currentPageId = self.page.get.currentId();
				
				var pageId = self.page.get.id(pageName);
				if (pageId < 0){
					errorCallback();
					return false;
				}

				var _delFunc = function(){
					// check for active page
					var isCurrent = self.page.is.current(pageName);
					
					// overwrite pageName
					// WARNING: Do not remove this entry
					self._h.pages[pageId].id = "NULL";
					self._h.pages[pageId].model = {};

					// remove pageContent
					var cPage = $(self._objTpl.page+"[data-pos='"+pageId+"']");
					
					// goBack to prevPage
					if (isCurrent){
						cPage.removeClass("center").addClass("right");
						// wait for finish transaction
						window.setTimeout(function(){
							ko.cleanNode(cPage[0]);
							cPage.remove();
						},600);
						self.page.goBack(successCallback,errorCallback);
					}else{
						ko.cleanNode(cPage[0]);
						cPage.remove();

						// MDL-POINTER
						self.page.set.pointer(currentPageId);
						self.model.restore();
						successCallback();
					}
				};

				// MDL-POINTER
				self.page.set.pointer(pageId);
				self.model.onDelete(_delFunc,errorCallback);			
			},
			show: function(pageParams,successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;
				var handleOldPage = true;

				var pageId = self.page.get.id(pageParams.pageIdent);
				if (pageId < 0){
					return false;
				}				

				var _focusFunction = function(){
					var cPage = $(self._objTpl.page+"[data-pos='"+pageId+"']");
					cPage.removeClass("hidden").removeClass("right").addClass("center");

					// add this pages to history, if not disabled
					if (!pageParams.noHistory){
						self._h.sequence.push(pageId);
						self._h.memory.push(pageId);
					}

					var _disableFunction = function(oldPageId){
						var oldPage = $(self._objTpl.page+"[data-pos='"+oldPageId+"']");
						oldPage.addClass("hidden");
					};


					// MDL-POINTER : TO-OLD
					if (handleOldPage){
						self.page.set.pointer(cPageId);
						// fallback-check for 'undefined' very first init
						if (!_.isUndefined(cPageId)){
							self.model.afterBlur(function(){
								// hide old page after x-ms callback
								window.setTimeout(function(){
									_disableFunction(cPageId);
								},500);
							});
						}
					}

					// MDL-POINTER : TO-NEW
					self.page.set.pointer(pageId);
					successCallback();
				};

				var _showFunc = function(){
					// MDL-POINTER : TO-NEW
					self.page.set.pointer(pageId);
					self.model.restore();
					self.model.onFocus(_focusFunction,errorCallback);
				};

				// MDL-POINTER : TO-OLD
				var cPageId = self.page.get.currentId();
				self.page.set.pointer(cPageId);
				var cPageObj = self.page.get.current(true);


				// fallback-check for 'undefined' very first init
				if (!_.isUndefined(cPageId)){
					if (cPageObj.lvl != pageParams.pageLvl){
						handleOldPage = false;
						_showFunc();
					}else{
						self.model.onBlur(_showFunc,errorCallback);
					}
					
				}else{
					_showFunc();
				}
				

				return null;
			},
			goBackAvailable: function(){
				var self = app.nav;
				var pEnd = self.page.get.currentPos();				
				if (pEnd <= 0){
					return false;
				}
				return true;
			},
			goBack: function(successCallback,errorCallback){
				((!successCallback)?successCallback=function(d){}:null);
				((!errorCallback)?errorCallback=function(e){}:null);
				var self = app.nav;

				var _backCounter = 0;

				// goBack func
				var _goBackFunc = function(){
					var pEnd = self.page.get.currentPos();				
					if (pEnd <= 0){
						successCallback(_backCounter);
						return;
					}

					var pageId = self.page.get.currentId();
					var pageName = self.page.get.current();

					// hide callback
					var _hideCallback = function(newPageId,cB){
						var nPage = $(self._objTpl.page+"[data-pos='"+newPageId+"']");
						nPage.removeClass("transition").removeClass("hidden").removeClass("right").addClass("center").addClass("transition");

						var _disableFunction = function(oldPageId){
							var oldPage = $(self._objTpl.page+"[data-pos='"+oldPageId+"']");
							oldPage.addClass("hidden");
						};

						var _hideOldPage = function(){
							// do hide page
							var cPage = $(self._objTpl.page+"[data-pos='"+pageId+"']");
							cPage.removeClass("center").addClass("right");

							// MDL-POINTER : TO-OLD
							self.page.set.pointer(pageId);
							self.model.afterBlur(function(){
								// hide old page after x-ms callback
								window.setTimeout(function(){
									_disableFunction(pageId);
								},500);
							});

							self.model.afterBlur(); // no callbacks

							// check for empty deleted pages
							if (self.page.get.current() == "NULL"){
								_goBackFunc();
							}else{
								// MDL-POINTER : TO-NEW
								self.page.set.pointer(newPageId);
								successCallback(_backCounter);
							}
						};
						// 250 ms user exp. (like transition time)
						window.setTimeout(_hideOldPage,250);
					};

					// close callback
					var _closePage = function(){
						self._h.sequence.push(pageId);
						self._h.memory.splice(pEnd,1);
						var nPageId = self.page.get.currentId();
						// MDL-POINTER : TO-NEW
						self.page.set.pointer(nPageId);

						self.model.restore();
						self.model.onFocus(
							function(){
								_hideCallback(nPageId);
							},
							errorCallback
						);
					};

					_backCounter++;

					// bring old page to front
					self.page.toFront(pageName,true);

					// MDL-POINTER : TO-OLD
					self.page.set.pointer(pageId);
					self.model.onBlur(_closePage,errorCallback);
				};

				// exec goBack
				_goBackFunc();
				
				return null;
			},
			toFront: function(pageName,dontMovePage){
				((!dontMovePage)?dontMovePage=false:null);
				var self = app.nav;
				
				var pageId = self.page.get.id(pageName);
				if (pageId < 0){
					return false;
				}
				
				// move container to the end
				var cPage = $(self._objTpl.page+"[data-pos='"+pageId+"']");
				// check for page
				if (cPage.length == 0){
					return false;
				}
				var pLvlContainer = cPage.parent();
				if (!dontMovePage){
					cPage.removeClass("transition").removeClass("center").addClass("right");
				}				
				cPage.detach().appendTo(pLvlContainer);
			},
			load: {
				dataLocation: function(dLocation,adaptReferences,successCallback,errorCallback){
					((!successCallback)?successCallback=function(d){}:null);
					((!errorCallback)?errorCallback=function(e){}:null);
					((!adaptReferences)?adaptReferences=false:null);
					var self = app.nav;
					
					// remove '/' prefix
					if(dLocation.charAt(0)=="/"){
						dLocation = dLocation.substring(1);
					}
					
					console.info("nav.load.dataLocation: "+GLOBALS.includePath+dLocation);
					loadXmlHttpFile(
						GLOBALS.includePath+dLocation,
						function(dContent){
							if (adaptReferences){
								self._adaptReferences(dContent,successCallback);
							}else{
								successCallback(dContent);
							}
						},
						errorCallback
					);
					return;
				},
				cssFiles: function(cssFiles,successCallback,errorCallback){
					((!successCallback)?successCallback=function(d){}:null);
					((!errorCallback)?errorCallback=function(e){}:null);
					var self = app.nav;

					var cssFileArray = cssFiles;

					var _createDataNode = function(fContent){
						// add a DOM object
						createCSSDataNode(fContent);
						_loadFileContent(cssFileArray.pop());
					};

					var _loadFileContent = function(cFile){
						// break condition
						if (_.isNull(cFile) || _.isEmpty(cFile)){
							successCallback();
							return;
						}

						// check for dynamicLoadingData
						if ((!_.isUndefined(cFile.dataLocation)) && (!_.isEmpty(cFile.dataLocation))){							
							self.page.load.dataLocation(
								cFile.dataLocation,
								true, // adaptReferences
								function(d){
									// add a DOM object
									createCSSDataNode(d);
									_loadFileContent(cssFileArray.pop());
								},
								errorCallback
							);
							return;
						}

						// getFileContent
						app.helper.storage.file.get(
							cFile.dataKey,
							cFile.dataStorageType,
							function(d){
								console.info("nav.load.cssFile: "+cFile.dataKey);								
								self._adaptReferences(d,_createDataNode);
							},
							errorCallback
						);
					};
					// do rec func
					_loadFileContent(cssFileArray.pop());
				},
				jsFiles: function(jsFiles,successCallback,errorCallback){
					((!successCallback)?successCallback=function(d){}:null);
					((!errorCallback)?errorCallback=function(e){}:null);
					var self = app.nav;

					var jsFileArray = jsFiles;

					var _loadFileContent = function(cFile){
						// break condition
						if (_.isNull(cFile) || _.isEmpty(cFile)){
							successCallback();
							return;
						}

						// check for dynamicLoadingData
						if ((!_.isUndefined(cFile.dataLocation)) && (!_.isEmpty(cFile.dataLocation))){							
							self.page.load.dataLocation(
								cFile.dataLocation,
								false, // adaptReferences
								function(d){
									// add a DOM object
									createJSDataNode(d);
									_loadFileContent(jsFileArray.pop());
								},
								errorCallback
							);
							return;
						}

						// getFileContent
						app.helper.storage.file.get(
							cFile.dataKey,
							cFile.dataStorageType,
							function(d){
								console.info("nav.load.jsFile: "+cFile.dataKey);
								// add a DOM object
								createJSDataNode(d);
								_loadFileContent(jsFileArray.pop());
							},
							errorCallback
						);
					};
					// do rec func
					_loadFileContent(jsFileArray.pop());
				},
				hashPage: function(pageName,pageParams,successCallback,errorCallback){
					((!successCallback)?successCallback=function(d){}:null);
					((!errorCallback)?errorCallback=function(e){}:null);
					var self = app.nav;

					// clear modelData, first
					self.model.clear();
					
					// get fileMap
					var fileMappingData = self._getMapData(pageName);
		
					if (_.isNull(fileMappingData.html)){
						console.error("nav.loadPage: "+pageName);
						errorCallback("nav.pageNotFound");
						return;
					}
		
					// create new pageObj
					var cPageObj = self.page.add(pageParams.pageIdent,pageParams.pageLvl);

					// doMDL func data
					var _finalizeLoad = function(){
						self.model.add();
						self.model.assignFunctions(pageParams);
						self.model.onLoad(successCallback,errorCallback);
					};

					var _loadCss = function(){
						self.page.load.cssFiles(fileMappingData.css,_loadJs,errorCallback);
					};

					var _loadJs = function(){
						self.page.load.jsFiles(fileMappingData.js,_finalizeLoad,errorCallback);
					};

					var _adaptCallbackFunc = function(newPageData){
						cPageObj.html(newPageData);

						// load css + js + modelFUNC + successCallback
						_loadCss();
					};
		
					// pageUpdate function (man adapt references)
					var _updatePage = function(pContent){
						self._adaptReferences(pContent,_adaptCallbackFunc);
					};
					
					// check for dynamicLoadingData
					if ((!_.isUndefined(fileMappingData.html.dataLocation)) && (!_.isEmpty(fileMappingData.html.dataLocation))){						
						self.page.load.dataLocation(
							fileMappingData.html.dataLocation,
							true, // adaptReferences
							_adaptCallbackFunc,
							function(e){
								// delete old pageContent
								self.page.remove(pageParams.pageIdent);
								console.error("nav.load.hashPage: "+iconvUrl,e);
								errorCallback(e);
							}
						);
						return;
					}
		
					// getFileContent
					app.helper.storage.file.get(
						fileMappingData.html.dataKey,
						fileMappingData.html.dataStorageType,
						_updatePage,
						function(e){
							// delete old pageContent
							self.page.remove(pageParams.pageIdent);
							console.error("nav.load.hashPage: "+pageName,e);
							errorCallback(e);
						}
					);
					return null;
				},
				webPage: function(pageKey,pageParams,successCallback,errorCallback){
					((!successCallback)?successCallback=function(d){}:null);
					((!errorCallback)?errorCallback=function(e){}:null);
					var self = app.nav;

					// clear modelData, first
					self.model.clear();
					
					// create new pageObj
					var cPageObj = self.page.add(pageParams.pageIdent,pageParams.pageLvl);

					var _adaptCallbackFunc = function(newPageData){
						cPageObj.html(newPageData);

						// model func
						self.model.add();
						self.model.assignFunctions(pageParams);
						self.model.onLoad(successCallback,errorCallback);
					};
		
					// pageUpdate function
					var _updatePage = function(pContent){
						self._adaptReferences(pContent,_adaptCallbackFunc);
					};
					
					// do API-FILE REQUEST
					app.api.doRequestAsync(
						pageKey,
						_.clone(pageParams),
						'get',
						_updatePage,
						function(e){
							// delete old pageContent
							self.page.remove(pageParams.pageIdent);
							console.error("nav.load.webPage: "+pageKey,e);
							errorCallback(e);
						}
					);
					return null;
				},
				httpPage: function(pageUrl,pageParams,successCallback,errorCallback){
					((!successCallback)?successCallback=function(d){}:null);
					((!errorCallback)?errorCallback=function(e){}:null);
					var self = app.nav;

					// clear modelData, first
					self.model.clear();
					
					var iconvUrl = pageUrl;
					if (!_.isEmpty(pageParams)){
						iconvUrl = pageUrl+"?"+uriConv(pageParams);
					}
					
					// create new pageObj
					var cPageObj = self.page.add(pageParams.pageIdent,pageParams.pageLvl);

					var _adaptCallbackFunc = function(newPageData){
						cPageObj.html(newPageData);

						// model func
						self.model.add();
						self.model.assignFunctions(pageParams);
						self.model.onLoad(successCallback,errorCallback);
					};
		
					// pageUpdate function
					var _updatePage = function(pContent){
						self._adaptReferences(pContent,_adaptCallbackFunc);
					};
					
					loadXmlHttpFile(
						iconvUrl,
						_updatePage,
						function(e){
							// delete old pageContent
							self.page.remove(pageParams.pageIdent);
							console.error("nav.loadHttpPage: "+iconvUrl,e);
							errorCallback(e);
						}
					);
				}
			}
		},
		showLevel: function(lvlId,hideOthers,doneFunction){
			((!hideOthers)?hideOthers=false:null);
			((!doneFunction)?doneFunction=function(){}:null);
			var self = this;

			if (hideOthers){
		        $(self._objTpl.pageLvl).fadeOut(500);
		    }

		    $(self._objTpl.pageLvl+'[data-lvl="'+lvlId+'"]').stop().fadeIn(500,doneFunction);
		    console.info("nav.showLevel: "+lvlId);
		},
		hideLevel: function(lvlId,doneFunction){
			((!doneFunction)?doneFunction=function(){}:null);
			var self = this;

		    $(self._objTpl.pageLvl+'[data-lvl="'+lvlId+'"]').stop().fadeOut(500,doneFunction);
		    console.info("nav.hideLevel: "+lvlId);
		},
		showContainer: function(contentName,ignoreOthers,doneFunction){
			((!doneFunction)?doneFunction=function(){}:null);
		    ((!ignoreOthers)?ignoreOthers=false:null);
		    var self = this;

		    if (!ignoreOthers){
		        $(self._objTpl.content).fadeOut(500);
		    }
		    $(self._objTpl.content+'[data-type="'+contentName+'"]').stop().fadeIn(500,doneFunction);
		    console.info("nav.showContainer: "+contentName);
		},
		hideContainer: function(contentName,doneFunction){
			((!doneFunction)?doneFunction=function(){}:null);
			var self = this;
		    $(self._objTpl.content+'[data-type="'+contentName+'"]').stop().fadeOut(500,doneFunction);
		    console.info("nav.hideContainer: "+contentName);
		},
		removePage: function(pageName,successCallback,errorCallback){
			((!successCallback)?successCallback=function(d){}:null);
			((!errorCallback)?errorCallback=function(e){}:null);
			var self = this;
			
			self.page.remove(pageName,successCallback,errorCallback);
			return null;
		},
		loadWindow: function(url, windowParams, registerCallbacks){
			return app.helper.nav.window.open(url, windowParams, registerCallbacks);
		},
		hasRedirect: function(){
			return !_.isEmpty(GLOBALS.redirect);
		},
		loadRedirect: function(successCallback,errorCallback){
			((!successCallback)?successCallback=function(d){}:null);
			((!errorCallback)?errorCallback=function(e){}:null);
			var self = this;

			if (!_.isEmpty(GLOBALS.redirect)){
				switch (GLOBALS.redirect.action){
					case "page":
						var pageName = GLOBALS.redirect.page;
						var pParams = _.clone(GLOBALS.redirect);
						delete pParams.action;
						delete pParams.page;

						// clear redirect link
						GLOBALS.redirect = {};
						self.loadPage(pageName,pParams,successCallback,errorCallback);
					break;
					case "model":
						var modelName = GLOBALS.redirect.model;
						var modelFunc = GLOBALS.redirect.function;
						// clear redirect link
						GLOBALS.redirect = {};
						models(modelName)[modelFunc](successCallback,errorCallback);
					break;
					default:
						// clear redirect link
						GLOBALS.redirect = {};
						errorCallback();
					break;
				}
			}else{
				errorCallback();
			}			
			return;
		},
		loadPage: function(pageName,pageParams,successCallback,errorCallback){
			((!successCallback)?successCallback=function(d){}:null);
			((!errorCallback)?errorCallback=function(e){}:null);
			((!pageParams)?pageParams={}:null);
			var self = this;

			var oldId = self.page.get.pointer();

			var _checkRestore = function(){
				if ((!_.isUndefined(pageParams.restoreModel)) && pageParams.restoreModel){
					self.page.set.pointer(oldId);
					self.model.restore();
				}
				successCallback();
			}
			
			// create ident
			pageParams.pageIdent = pageName;

			// check for 'id' - always use this for ident
			if (!_.isUndefined(pageParams.id)){
				pageParams.pageIdent += "_"+pageParams.id;
			}

			
			// check for 'force' - always create a new page
			if (!_.isUndefined(pageParams.force)){
				pageParams.pageIdent += "_"+uuid(8);
			}

			// check for 'pageLvl' - load a single page into a pageLevelContainer
			if (_.isUndefined(pageParams.pageLvl)){
				pageParams.pageLvl = 0;
			}

			// check for 'noHistory' - do not load this to history
			if (_.isUndefined(pageParams.noHistory)){
				pageParams.noHistory = false;
			}
			
			// check for current page
			if (self.page.is.current(pageParams.pageIdent)){
				_checkRestore();
				return false;
			}

			self.showContainer("loading",true);
			
			// check, if page is loaded once
			if (self.page.is.loadedPage(pageParams.pageIdent)){
				// bring page to front-pos
				self.page.toFront(pageParams.pageIdent);
				
				// wait 250ms user exp. (like transition time)
				window.setTimeout(function(){
					self.page.show(
						pageParams,
						function(){
							self.hideContainer("loading");
							console.info("nav.loadPage: "+pageName,"toFront");
							self.model._callRegisterFunc("changePage",{'pageName': pageName, 'pageParams': pageParams});
							self.model._callRegisterFunc("refreshHistory");

							// call the after show function
							self.model.afterShow(_checkRestore);
						},
						errorCallback
					);
					
				},250);
				return true;
			}
			
			// this function shows the new page
			var _updateView = function(){
				// wait 250ms user exp. (like transition time)
				window.setTimeout(function(){
					self.page.show(
						pageParams,
						function(){
							self.hideContainer("loading");
							console.info("nav.loadPage: "+pageName,"load success");
							self.model._callRegisterFunc("changePage",{'pageName': pageName, 'pageParams': pageParams});
							self.model._callRegisterFunc("refreshHistory");

							// call the after show function
							self.model.afterShow(_checkRestore);
						},
						errorCallback
					);
				},250);
			};
			
			// this function restores the old page
			var _restoreView = function(){
				self.hideContainer("loading");
				errorCallback();
			};
			
			// check, if page is a hashPage (read from manifest)
			if (pageName.substr(0,1) == "#"){
				// load new pageData to mainContainer
				self.page.load.hashPage(pageName,pageParams,_updateView,_restoreView);
			}else if (pageName.substr(0,1) == "/"){
				// load new pageData to mainContainer
				self.page.load.webPage(pageName,pageParams,_updateView,_restoreView);
			}else{
				// load new pageData to mainContainer
				self.page.load.httpPage(pageName,pageParams,_updateView,_restoreView);
			}
			return null;
		},
		goBack: function(successCallback,errorCallback){
			((!successCallback)?successCallback=function(d){}:null);
			((!errorCallback)?errorCallback=function(e){}:null);
			var self = this;

			// check for regCallbacks
			/* TODO: check in iOS - */
			if (!self.model._callRegisterFunc('goBackCheck')){
				successCallback();
				return;
			}

			var _goBackHandle = function(){
				self.page.goBack(
					function(c){
						self.hideContainer("loading");
						console.info("nav.goBack: success ("+c+")");
						var cMdl = self.model.get();
						self.model._callRegisterFunc("changePage",{'pageName': cMdl.id(), 'pageParams': cMdl.params.getAll()});
						self.model._callRegisterFunc("refreshHistory");

						// call the after show function
						self.model.afterShow(function(){
							successCallback(c);
						});
					},
					function(e){
						console.error("nav.goBack: error",e);
						errorCallback(e);
					}
				);
			};

			self.showContainer("loading",true);

			window.setTimeout(function(){
				_goBackHandle();
			},500);
			
			
			return null;
		},
		_adaptReferences: function(data,resultCallback) {
			var self = this;

			var refPrefix = app.settings.get("REF_PREFIX");
			var refRegEx = new RegExp(refPrefix+"([a-zA-Z0-9_\./]+)", 'g');

			// get a unique array of all replaceable elements
			var matchElements = _.uniq(data.match(refRegEx));

			// removes the prefix '#app:'
			var _realPath = function(pD){
				return pD.replace(refPrefix,"");
			};

			// get data from cache
			var _getCache = function(repKey){
				if (!_.isUndefined(self._referenceCache[repKey])){
					return self._referenceCache[repKey];
				}
				return null;
			};

			// set data to cache
			var _setCache = function(repKey,repValue){
				if ((!_.isUndefined(repValue)) && (!_.isEmpty(repValue))){
					self._referenceCache[repKey] = repValue;
				}
			};

			// replace this in 'data'
			var _replaceData = function(repKey,repValue){
				var re = new RegExp(repKey, 'g');
				data = data.replace(re,repValue);
			};

			// single replace func (foreach)
			var _pathReplaceFunc = function(cPath){
				// break condition
				if (_.isNull(cPath) || _.isEmpty(cPath)){
					resultCallback(data);
					return;
				}

				// get old replacement from cache
				var cachedValue = _getCache(cPath);

				// key in cache found, replace from cache
				if (!_.isNull(cachedValue)){
					_replaceData(cPath,cachedValue);

					// request next element
					_pathReplaceFunc(matchElements.pop());
				}else{
					// get the realPath (this is stored in 'fs','sql')
					var rPath = _realPath(cPath);

					app.helper.storage.file.getLocationDataMap(
						rPath,
						function(dMap){
							if (dMap.status){
								// file-location found
								if (!_.isNull(dMap.location)){
									// replacement found, replace it
									_replaceData(cPath,dMap.location);

									// store this to cache
									_setCache(cPath,dMap.location);
								// file-data found
								}else if(!_.isNull(dMap.data)){
									// check for img
									var mType = dMap.type.split("/")[0];
									if (mType == "image"){
										var imgReplacePath = "data:"+dMap.type+";base64,"+dMap.data;
										// replacement, don't store this data
										_replaceData(cPath,imgReplacePath);
									}else{
										// replacement, don't store this data
										_replaceData(cPath,dMap.data);
									}
								}
							// default backup for missing files in manifest
							}else{
								var newPath = rPath;

								// remove '/' prefix
								if(newPath.charAt(0)=="/"){
									newPath = newPath.substring(1);
								}

								// replacement
								_replaceData(cPath,GLOBALS.includePath+newPath);

								// store this to cache
								_setCache(cPath,GLOBALS.includePath+newPath);
							}
							// request next element
							_pathReplaceFunc(matchElements.pop());
						},
						function(e){
							// ignore file errors and continue with next path
							_pathReplaceFunc(matchElements.pop());
						}
					);
				}
			};

			console.info("nav.adaptReferences");

			// check for null elements
			if (_.isNull(matchElements)){
				resultCallback(data);
				return null;
			}

			// first init
			_pathReplaceFunc(matchElements.pop());
			
			return null;
		},
		_getMapData: function(pageName){
			var cManifest = app.settings.get("MANIFEST");
			var mappingData = {html:null,js:[],css:[]};
			_.forEach(cManifest.dataFiles,function(fData){
				if (fData.dataMapping == pageName){
					switch (fData.dataMimeType){
						case 'text/html':
							mappingData['html'] = fData;
						break;
						case 'application/javascript':
							mappingData['js'].push(fData);
						break;
						case 'text/css':
							mappingData['css'].push(fData);
						break;
					}
				}
			});
			return mappingData;
		},
		_init: function(){
			var self = this;
			// register READY
			eListener.register(["rus"],app.nav._initReady);
		},
		_initReady: function(){
			// reference to global - unable to load through eListener ('this' is eListener)
			var self = app.nav;

			_.setReady(self);
		}
	};
	app.nav._init();
})(window.app,model);